<?php

require_once('common.php');
require_once('lib/format.inc');
require_once('dListConst.inc');

function cdx($bsk) {
$cdy = $bsk->getPreferredEmailAddress();
$amm = $cdy['address'];
$cdz = $bsk->getPhoneNumbers();
$ce0 = array();
if (count($cdz) > 0) foreach ($cdz as $cea) {
$ce0[$cea['type']] = $cea['number'];
}
$ceb = array();
$ceb['Home'] = $bsk->getHomeAddress();
$ceb['Business'] = $bsk->getWorkAddress();
$ceb['Other'] = $bsk->getOtherAddress();
foreach ($ceb as $ajk => $aoe) {
$aod = $aoe['locality'];
$aod = $aoe['zip'] . (($aod && $aoe['zip']) ? ' ' . $aod : $aod);
$aod = $aoe['street'] . (($aod && $aoe['street']) ? ', ' . $aod : $aod);
$bss[$ajk] = $aod;
}
unset($aod);
$dn = $bsk->getCommonName();
$a0y = 200;
if ($bsk->isDList()) {
$cec = '"'. aaz('dlist') . '"';
} else {
$cec = afh(aa0(aaa($amm, $a0y)));
}
$dx = afh(aa0(aaa($dn, $a0y))) . ','
. afh(aa0(aaa($bsk->getSurName(), $a0y))) . ','
. afh(aa0(aaa($bsk->getFirstName(), $a0y))) . ','
. $cec . ','
. afh(aa0(aaa($bsk->getCompanyName(), $a0y))) . ','
. afh(aa0(aaa($bsk->getProfession(), $a0y))) . ','
. afh(aa0(aaa($bsk->getDepartmentName(), $a0y))) . ','
. afh(aa0(aaa($ce0[KMS_WORKVOICE], $a0y))) . ','
. afh(aa0(aaa($ce0[KMS_WORKFAX], $a0y))) . ','
. afh(aa0(aaa($ce0[KMS_HOMEVOICE], $a0y))) . ','
. afh(aa0(aaa($ce0[KMS_MOBILE], $a0y))) . ','
. afh(aa0(aaa($ce0[KMS_COMPANY], $a0y))) . ','
. afh(aa0(aaa($ce0[KMS_OTHERVOICE], $a0y))) . ','
. afh(aa0(aaa($ce0[KMS_OTHERFAX], $a0y))) . ','
. afh(aa0(aaa($bsk->getHomeUrl(), $a0y))) . ','
. afh(aa0(aaa($bsk->getWorkUrl(), $a0y))) . ','
. afh(aa0(aaa($bsk->getOtherUrl(), $a0y))) . ','
. afh(aa0(aaa($bss['Home'], $a0y))) . ','
. afh(aa0(aaa($bss['Business'], $a0y))) . ','
. afh(aa0(aaa($bss['Other'], $a0y))) . ','
. afh(aa0(aaa($bsk->getIMAddress(), $a0y)));
return $dx;
}

function ced($ajk) {
switch($ajk) {
case KMS_ASSISTANT: $ni = aaz('contact-ph-assistant'); break;
case KMS_WORKVOICE: $ni = aaz('contact-ph-business'); break;
case KMS_WORKFAX: $ni = aaz('contact-ph-business-fax'); break;
case KMS_CALLBACK: $ni = aaz('contact-ph-callback'); break;
case KMS_CAR: $ni = aaz('contact-ph-car'); break;
case KMS_COMPANY: $ni = aaz('contact-ph-company'); break;
case KMS_HOMEVOICE: $ni = aaz('contact-ph-home'); break;
case KMS_HOMEFAX: $ni = aaz('contact-ph-home-fax'); break;
case KMS_ISDN: $ni = aaz('contact-ph-isdn'); break;
case KMS_MOBILE: $ni = aaz('contact-ph-mobile'); break;
case KMS_OTHERVOICE: $ni = aaz('contact-ph-other'); break;
case KMS_OTHERFAX: $ni = aaz('contact-ph-other-fax'); break;
case KMS_PAGER: $ni = aaz('contact-ph-page'); break;
case KMS_PRIMARY: $ni = aaz('contact-ph-primary'); break;
case KMS_RADIO: $ni = aaz('contact-ph-radio'); break;
case KMS_TELEX: $ni = aaz('contact-ph-telex'); break;
case KMS_TTYTDD: $ni = aaz('contact-ph-ttyttd'); break;
default: $ni = false; break; }
return $ni;
}

function cee($ajk) {
switch ($ajk) {
case 'Home': $ni = aaz('contact-web-home'); break;
case 'Business': $ni = aaz('contact-web-business'); break;
case 'Other': $ni = aaz('contact-web-other'); break;
case 'FreeBusy': $ni = aaz('contact-free-busy'); break;
case 'Calendar': $ni = aaz('contact-calendar-uri'); break;
default: $ni = aaz('contact-web'); break;
}
return $ni;
}

function ceg($bi0, $ceh, $cei = true) {
if (trim(strip_tags($ceh)) == "") $ceh = "";
if (!empty($ceh) && $ceh != '19700101') { if ($cei) {
$bi0 = aa0($bi0);
$ceh = cej(aa0($ceh));
}
$dx = '<tr><td width="75"><nobr>' . $bi0
. ':</nobr></td><td width="100%"><div class="addressCardValueDiv">'
. $ceh . '</div></td></tr>';
return $dx;
}
}

function cef($bsk, $zd, $cek) {
$a0y = 100;
$cel = $bsk->getFirstName();
$cem = $bsk->getMiddleName();
$cen = $bsk->getSurName();
$ceo = $bsk->getCommonName();
$cep = $bsk->getFileAsName();
$ceq = $bsk->getNickName();
$cer = $bsk->getTitleBefore();
$ces = $bsk->getTitleAfter();
$cdz = $bsk->getPhoneNumbers();
$aij = $bsk->getEmailAddresses();
$ceb['Home'] = $bsk->getHomeAddress();
$ceb['Business'] = $bsk->getWorkAddress();
$ceb['Other'] = $bsk->getOtherAddress();
$cet['Home'] = $bsk->getHomeUrl();
$cet['Business'] = $bsk->getWorkUrl();
$cet['Other'] = $bsk->getOtherUrl();
$ceu['FreeBusy'] = $bsk->getFreeBusyUrl();
$ceu['Calendar'] = $bsk->getCalendarUri();
$ceu['Birthday'] = $bsk->getBirthDay();
$ceu['Anniversary'] = $bsk->getAnniversary();
$ceu['Company'] = $bsk->getCompanyName();
$ceu['Department'] = $bsk->getDepartmentName();
$ceu['Office'] = $bsk->getOfficeNumber();
$ceu['Job title'] = $bsk->getProfession();
$ceu['Comment'] = $bsk->getComment();
$ceu['IM Address'] = $bsk->getIMAddress();
$ceu['Manager name'] = $bsk->getManagerName();
$ceu['Assistant name'] = $bsk->getAssistantName();
$cev = ($cep) ? $cep : $ceo;
$cev = ($cev) ? $cev : $cen;
if ($bsk->isDList()) {
$cev = $ceo;
$cew = '1';
$cex = '<th class="dListCardViewName"><img src="' . DLIST_ICON_EMBEDDED_LIST . '"></th>';
$cey = 'isDlist="1"';
$cez = '';
} else {
$cev = $cev;
$cew = '0';
$cex = '';
$cey = 'isDlist="0"';
$cez = ' colspan="2"';
}
$cf0 = '<div class="addressCardDiv"><table isSelectable="true" number="' . $cek . '" width="100%" class="addressCard" cellpadding="0" cellspacing="0" '
. 'type="' . KMS_FCONTACT . '" uid="' . $zd . '" isDList="' . $cew . '" '
. ' OnDblClick="cfa(event);return false;" '
. 'OnMouseDown="cfb(event); return false;" OnMouseUp="cfc(event);">'
. '<tr><th' . $cez . '><div class="addressCardValueDiv" ' . $cey . '>'
. cej(aa0(aaa($cev, $a0y))) . '&nbsp;</div></th>' . $cex . '</tr>';
if ($cem || $ceq || $cer || $ces) {
$cfd = $cer . " " . $cel . " " . $cem;
$cfd .= ($ceq ? " '" . $ceq . "' " : " ") . $cen . " " . $ces;
}
$cfe = array(
'Home' => aaz('contact-home'),
'Business' => aaz('contact-business'),
'Other' => aaz('contact-other')
);
foreach ($ceb as $ajk => $cff) {
$cfg = ($cff['locality'] && $cff['state']) ? ",</nobr> " : "</nobr> ";
$aod = cej(aa0(aaa($cff['street'], $a0y))) . ' '
. '<nobr>' . cej(aa0(aaa($cff['locality'], $a0y))) . $cfg
. '<nobr>' . cej(aa0(aaa($cff['state'], $a0y))) . '</nobr> '
. '<nobr>' . cej(aa0(aaa($cff['zip'], $a0y))) . '</nobr> '
. '<nobr>' . cej(aa0(aaa($cff['country'], $a0y))) . '</nobr>';
if (trim(strip_tags($aod)) != '') $cf0 .= ceg($cfe[$ajk], $aod, false);
unset($aod);
}
if (count($cdz) > 0) {
foreach ($cdz as $cfh) {
$cf0 .= ceg(ced($cfh['type']), aaa($cfh['number'], $a0y));
}
}
$cfi = array();
foreach ($aij as $cfj) {
if (1 == $cfj['preferred']) {
array_unshift($cfi, $cfj);
} else {
$cfi[] = $cfj;
}
}
for ($az = 0; $az < count($cfi); $az++) {
$cfj = $cfi[$az];
if (!empty($cfj['address'])) {
$alh = $az + 1;
$bi0 = ($az > 0 ? aaz("contact-email") . " $alh" : aaz("contact-email"));
$ceh = '<a href="javascript:eval();" onclick="c0t(\'new\',\'' . urlencode($cfj['address']) . '\');">'
. '<nobr>' . cej(aa0(aaa($cfj['address'], $a0y * 2))) . '</nobr></a>';
$cf0 .= ceg($bi0, $ceh, false);
}
}
foreach ($cet as $ajk => $cfk) {
if (!empty($cfk)) {
$cfk = aa0($cfk);
$cfl = (substr($cfk, 0, 4) == "http") ? $cfk : 'http://' . $cfk;
$cf0 .= ceg(aaz("contact-web-" . strtolower($ajk)), '<a href="' . $cfl . '" target="_blank">' . cej(aaa($cfk, $a0y)) . '</a>', false);
}
}
$cf0 .= '</table></div>';
echo "cfm += \"" . ahi($cf0) . "\";\n";
} 
function cfn($abq, $yx, $cfo, $cfp = false) {
echo "aff.agj();\n";
echo "var cfm = '';\n";
$agn = '<div id="addressCardsDiv">'
. '<table id="addressCardsTable" style="table-layout: fixed; width:100%;" cellpadding="0" cellspacing="0"><tr>';
echo "cfm +=\"" . ahi($agn) . "\";\n";
$cfq = 0;
$alh = 0;
$cfr = $cfo - $yx + 1;
$cfs = 3;
for ($abq->gotoNumber(0), $az = 0; ($abq->isValid() && ($az < $cfr)); $abq->gotoNext(), $az++) {
$bsk = $abq->getContact();
if (!is_null($bsk)) {
if ($alh == 0) {
echo "cfm +=\"" . ahi("<td width=\"33%\" valign=\"top\" style='padding-left:5px;'>") . "\";\n";
}
cef($bsk, $abq->getUID(), $cfq);
$cfq++;
if ($alh == ceil($cfr / $cfs) - 1) {
$alh = -1;
echo "cfm +=\"" . ahi('</td>') . "\";\n";
}
++$alh;
}
}
if ($cfq <= ceil($cfr / $cfs) - 1)
echo "cfm += \"" . ahi("<td width=\"33%\" valign=\"top\">&nbsp;</td>") . "\";\n";
if ($cfq <= (ceil($cfr / $cfs) - 1) * 2)
echo "cfm += \"" . ahi("<td width=\"33%\" valign=\"top\">&nbsp;</td>") . "\";\n";
$agn = "</tr></table></div>";
echo "cfm +=\"" . ahi($agn) . "\";\n";
echo "aff.ahh(cfm);\n";
echo "aff.cft();\n";
echo "aff.document.getElementById('mainTitle').innerHTML = '<kerio:text id=\"fld-contacts\"/>'\n";
echo "aff.document.getElementById('frameMainHeader').style.display = '';\n";
if ($cfp) {
echo "aff.cfu('$cfp');\n";
echo "aff.cfv('$cfp');\n";
}
}

function cfw($aek, $cfx) {
global $agi, $abm, $n0, $ak, $agi;
echo "aff.cfy();\n";
$cfz = KMS_SORTVCARDFILEAS;
$cg0 = 0;
$abi = $ak->getFolderStore();
$abo = $abi->openContactFolder($aek);
$abq = $abo->createContactMessageIterator(KMS_FAREADONLY);
$cga = array(array('key'=>$cfz,'reverse'=>$cg0));
$anb = $abo->sortMessages($cga, $n0, 0, 0);
$abq->setSubset($anb);
$cgb = 0;
$cgc = false;
$cgd = '';
for ($az = 0; $az < 36; $az++) {
$cgd[] = chr(ord(strtoupper($cfx)) + $az);
if (chr(ord(strtoupper($cfx)) + $az) == 'Z') break;
}
$cge = false;
for ($az = 0; $az < sizeof($cgd); $az++) {
$cfx = $cgd[$az];
$an0 = ' (#All) ';
$ala = $abo->searchMessages(&$cgf, &$alc, $an0, array());
if ($ala != 0) {
cgg($ala);
return false;
}
$cgf = $abo->sortMessageSet($cga, $n0, 0, 0, $cgf);
$abq->setSubset($cgf);
for ($abq->gotoNumber(0); $abq->isValid(); $abq->gotoNext()) {
$bsk = $abq->getContact();
if (is_null($bsk)) continue;
$cev = ($bsk->getFileAsName()) ? $bsk->getFileAsName() : $bsk->getCommonName();
$cev = ($cev) ? $cev : $bsk->getSurName();
if (mb_strtolower(mb_substr($cev, 0, 1, 'UTF-8'), 'UTF-8') == mb_strtolower($cfx, 'UTF-8')) {
$cge = true;
break;
}
}
if ($cge) break;
}
$cgc = ($abq->getUid()) ? $abq->getUid() : false;
$abq = $abo->createContactMessageIterator(KMS_FAREADONLY);
$anb = $abo->sortMessages($cga, $n0, 0, 0);
$abq->setSubset($anb);
$cgh = $anb->size();
$e = 0;
$cgi = $agi["messageCount"];
if ($cgc) {
for ($abq->gotoNumber(0), $az = 0; ($abq->isValid()); $abq->gotoNext(), $az++) {
if ( $az > 0 && ($az / $cgi) == round($az / $cgi) ) {
$e++;
}
if ($cgc == $abq->getUid()) {
break;
}
}
$cgj = ($e) * $cgi;
}
else {
$cgj = 0;
}
$cgk = min($anb->size(), $cgj + $cgi);
$abq = $abo->createContactMessageIterator(KMS_FAREADONLY);
$anb = $abo->sortMessages($cga, $n0, $cgj, $cgi);
$abq->setSubset($anb);
cfn($abq, $cgj, $cgk, $cgc);
$e = floor($cgj / $cgi) + 1;
echo 'var c0v=aff.afi.afj; '.cgl($e, $cgh)
. 'aff.document.getElementById("contactSearchValue").value = "";' . "\n"
.'aff.document.getElementById("contactSearchBtnClear").disabled = true;' . "\n";
}

function bsv($aek,$zd){
global $ak, $abm;
$abi = $ak->getFolderStore();
$abo = $abi->openContactFolder($aek);
if (is_null($abo)) {
echo "alert('Error: unable to open folder ".$aek."')";
return false;
}
$abq = $abo->createContactMessageIterator(KMS_FAREADONLY);
$abq->gotoUid($zd);
if (!$abq->isValid()) {
aeq('E_MESSAGE_BADUID',$aek);
aer('saveContact','E_MESSAGE_BADUID', "folder: " . $aek . "; uid: " . base_convert($zd, 10, 16));
}
return $abq->getContact();
}

function cgn($aek, &$zd, $dn, $cgm, $amm, $bss, $cfl, $ceu, $ahv) {
global $ak, $abm;
$cgo = Array();
$abi = $ak->getFolderStore();
$abo = $abi->openContactFolder($aek); if (is_null($abo)) {
$aek = '~' . $abm->getUserName() . '/' . FLD_CONTACT;
$abo = abp($aek, KMS_FCONTACT);
if ($abo) {
$cgo[] = SAVED_IN_DEFAULT_FOLDER;
}
}
$cgp = false;
if (empty($zd)) {
$abv = kerio('KMS::ContactW');
$cgp = true;
}
else {
$abq = abr($abo, KMS_FCONTACT);
if ($abq->gotoUid($zd)) {
$cgq = $abq->getContact();
$abv = $cgq->copy();
}
else {
$abv = kerio('KMS::ContactW'); $cgp = true;
}
}
$abv->setFirstName($dn['cgr']);
$abv->setMiddleName($dn['cgs']);
$abv->setSurName($dn['cgt']);
$dn['cgu'] = "";
$cgv = array();
if ($dn['cgw']) array_push($cgv,$dn['cgw']);
if ($dn['cgr']) array_push($cgv,$dn['cgr']);
if ($dn['cgs']) array_push($cgv,$dn['cgs']);
if ($dn['cgt']) array_push($cgv,$dn['cgt']);
if ($dn['cgx']) array_push($cgv,$dn['cgx']);
$dn['cgu'] = implode(" ",$cgv);
$abv->setCommonName($dn['cgu']);
$cep = '';
$cgy = $dn['cgt'];
if ($dn['cgr'] !='' || $dn['cgs']!= '') $cgy .=",";
if ($dn['cgr']!= '') $cgy .=" ".$dn['cgr'];
if ($dn['cgs']!= '') $cgy .=" ".$dn['cgs'];
if ($dn['cgz'] == 0){
$cep = $cgy;
} elseif ($dn['cgz'] == 1){
$cep = $dn['cgr'];
if ($dn['cgs'] != '') $cep .=" ".$dn['cgs'];
if ($dn['cgt'] != '') $cep .=" ".$dn['cgt'];
} elseif ($dn['cgz'] == 2){
if ($cgy) $cep = $cgy."\r\n";
$cep .= $ceu['ch0'];
} elseif ($dn['cgz'] == 3){
$cep = $ceu['ch0'];
if ($cgy) $cep .= "\r\n".$cgy;
} elseif ($dn['cgz'] == 4){
$cep = $dn['cgu'];
} else $cep = $dn['cgz'];
$dn['cgz'] = $cep;
$abv->setFileAsName($dn['cgz']);
$ahv = explode(';', str_replace(',', ';', $ahv)); $aik = $ahv;
$ahv = array();
for ($az = 0; $az < sizeOf($aik); ++$az){
$du = trim($aik[$az]);
if ($du && !in_array($du,$ahv)) array_push($ahv,$du);
}
$abv->setCategories($ahv);
if (sizeOf($ahv)) ail($ahv);
$aao = (0 == $ceu['axz']) ? KMS_CPUBLIC : KMS_CPRIVATE;
$abv->setClass($aao);
$abv->setNickName($dn['cha']);
$abv->setTitleBefore($dn['cgw']);
$abv->setTitleAfter($dn['cgx']);
$abv->setHomeUrl($cfl['chb']);
$abv->setWorkUrl($cfl['chc']);
$abv->setOtherUrl($cfl['chd']);
$abv->setFreeBusyUrl($ceu['che']);
$abv->setCalendarUri($ceu['chf']);
if ($ceu['chg'] != '') $abv->setBirthDay(strtotime($ceu['chg'])); else $abv->setBirthDay(-1);
if ($ceu['chh'] != '') $abv->setAnniversary(strtotime($ceu['chh']));
else $abv->setAnniversary(-1);
$abv->setCompanyName($ceu['ch0']);
$abv->setDepartmentName($ceu['chi']);
$abv->setOfficeNumber($ceu['chj']);
$abv->setProfession($ceu['chk']);
$abv->setComment($ceu['chl']);
$abv->setIMAddress($ceu['chm']);
$abv->setManagerName($ceu['chn']);
$abv->setAssistantName($ceu['cho']);
unset($cgm['chp']);
$abv->clearPhoneNumbers();
foreach ($cgm as $ajk => $ajd) {
if (!empty($ajd)) {
$cea = array('type' => $ajk, 'number' => $ajd);
$abv->addPhoneNumber($cea);
}
}
unset($amm['chp']);
$ajk = null;
if (!is_null($abv)) {
$chq = $abv->getEmailAddresses();
$chs = array();
foreach ($chq as $cht) {
$chs[] = $cht['type'];
}
}
$abv->clearEmailAddresses();
$chu = 0;
for ($az = 0; $az < count($amm); $az++) {
if (!empty($amm[$az]['ayp'])) {
if (!is_null($abv)) {
$ajk = $chs[$chu];
}
if ($cgp || is_null($ajk)) {
switch ($az) {
case 0:
$ajk = KMS_EHome;
break;
case 1:
$ajk = KMS_EWork;
break;
default:
$ajk = KMS_EOther;
break;
}
}
$anx = array('preferred' => ($az == 0) ? 1 : 0,
'address' => $amm[$az]['ayp'],
'name' => $amm[$az]['ayl'],
'type' => $ajk);
$abv->addEmailAddress($anx);
$chu++;
}
}
unset($chq);
unset($bss['chp']);
foreach ($bss as $ajk => $chv) {
$aoe = array(
'preferred' => ($chv['chw'] == '1') ? true : false,
'street' => $chv['chx'],
'locality' => $chv['chy'],
'zip' => $chv['chz'],
'state' => $chv['ci0'],
'country' => $chv['cia']
);
switch ($ajk) {
case 'chb': $abv->setHomeAddress($aoe); break;
case 'chc': $abv->setWorkAddress($aoe); break;
case 'chd': $abv->setOtherAddress($aoe); break;
default: $abv->setWorkAddress($aoe); break;
}
}
$aiq = SAVING_RESULT_FAILED;
if ($cgp) {
$zd = $abo->insertContact($abv);
if (0 < $zd) {
$aiq = SAVING_RESULT_OK;
$abq = abr($abo, KMS_FCONTACT);
}
}
else {
if (1 == $abq->saveContact($abv) ) {
$aiq = SAVING_RESULT_OK;
}
}
air($abq, $aek); 
unset($abq, $abv, $abo);

$cgo[] = $aiq;

return $cgo;
}


function cie($cib,$cic,$cid){
echo "var cif = false;\n";
echo "var bcx = false;\n";
for ($az = 0; $az < sizeOf($cic); ++$az){

cig($cib,$cic[$az],$cid[$az],0);
echo "var cif = cif || bcx;\n";
}
echo "if (cif) aff.cih(".afh($cib).");\n";
echo "aff.cii(".afh($cib).");\n";

}


function cig($cib, $cij, $cik, $cil = 1) {

if (trim($cik) == "") return;

$dn = "resArray" . time(); $cim = array(); 
$aml = kerio_parse_address_header($cik); foreach ($aml as $bss) {
$cge = bsu($bss);
$cim[$bss['address']] = (count($cge) ? $cge : array($bss['address'] => akm($bss))); }

print
cin($cim,$dn) .
"var bcx = aff.cio(" . afh($cib) . "," . afh($cij) . "," . $dn . "," . $cil . ");\n";
}



define('OUTPUT_FULL_ADDRESS' ,0);
define('OUTPUT_FOLDER_UID' ,1);



function bsu($bss, $cip = OUTPUT_FULL_ADDRESS) {
global $ak;

$ciq = cir(array('Surname', 'FirstName', 'MiddleName', 'NickName', 'DisplayName', 'Email', 'Company'), trim(implode(" ", $bss)));

$abi = $ak->getFolderStore();
$abm = $ak->getMyUserInfo();
$cis = $abi->listFolders("~" . $abm->getUserName() . "/*", KMS_FCONTACT, 0);

$cit = array(); 
if (is_array($cis)) foreach ($cis as $aek) {

$ciu = $abi->openContactFolder($aek['name']);

if (is_null($ciu)) continue;
$abq = $ciu->createContactMessageIterator(KMS_FAREADONLY);
$ala = $ciu->searchMessages(&$civ, &$alc, $ciq['str'], $ciq['val']);
unset($ciu); 
$abq->setSubset($civ);

for ($abq->gotoNumber(0); $abq->isValid(); $abq->gotoNext()) {

$bsk = $abq->getContact();
if (is_null($bsk)) continue;

$ciw = $bsk->getEmailAddresses(); if (count($ciw) == 0) continue; if ($cip == OUTPUT_FULL_ADDRESS) {
$aod = "";
foreach ($ciw as $amm) {
if (strpos($amm['address'], $bss['address']) !== false) {
if ($aod == "" || $amm['preferred']) $aod = $amm['address'];
}
}

if ($aod == "") {
foreach ($ciw as $amm) {
if ($aod == "" || $amm['preferred']) $aod = $amm['address'];
}
}

if ($aod != "") {

$dn = (strpos($aod, ",") === false ? $bsk->getCommonName() : ""); $bwj = strtolower($aod); if (trim($dn) != "") {
$dn = btj($dn); $cit[$bwj] = $dn . ' <' . $aod . ">";
}
else {
$cit[$bwj] = $aod;
}
}
}
elseif ($cip == OUTPUT_FOLDER_UID) {
$cit[] = array('folder' => $aek['name'], 'uid' => $abq->getUid());
}
}
unset($abq); }
return $cit;
}

function cin($cix,$dn){
$dx="".$dn."=new Array();".LF;
if (sizeof($cix)){
reset($cix);
while (list($bwj,$du)=each($cix)){
if (!is_array($du)) continue;
$dx.=$dn.".push(\"$bwj\");".LF;
$dx.=$dn."[\"$bwj\"]=new Array();".LF;
$ciy = array();
if (sizeOf($du)) foreach($du as $nr){
if (!in_array($nr,$ciy)){
$dx.=$dn."[\"$bwj\"].push(".afh($nr).");".LF;
array_push($ciy,$nr);
}
}
}
}
return $dx;
}

function ciz($aek, $zd, &$aab) {
global $ak;
$abi = $ak->getFolderStore();
$abo = $abi->openContactFolder($aek);
$qp = $ak->getMyUserInfo();
if ($zd) {
$abq = $abo->createContactMessageIterator(KMS_FAREADONLY);
unset($abo);
$abq->gotoUid($zd);
if (!$abq->isValid()) $ajp = true;
$bsk = $abq->getContact();
unset($abq);
if (!is_null($bsk)) {
$cel = $bsk->getFirstName();
$cem = $bsk->getMiddleName();
$cen = $bsk->getSurName();
$ceo = $bsk->getCommonName();
$ceq = $bsk->getNickName();
$cer = $bsk->getTitleBefore();
$ces = $bsk->getTitleAfter();
$cep = $bsk->getFileAsName();
$cdz = $bsk->getPhoneNumbers();
$aij = $bsk->getEmailAddresses();
$ceb['Home'] = $bsk->getHomeAddress();
$ceb['Business'] = $bsk->getWorkAddress();
$ceb['Other'] = $bsk->getOtherAddress();
$cet['Home'] = $bsk->getHomeUrl();
$cet['Business'] = $bsk->getWorkUrl();
$cet['Other'] = $bsk->getOtherUrl();
$cet['FreeBusy'] = $bsk->getFreeBusyUrl();
$cet['Calendar'] = $bsk->getCalendarUri();
$ceu['Birthday'] = $bsk->getBirthDay();
$ceu['Anniversary'] = $bsk->getAnniversary();
$ceu['Company'] = $bsk->getCompanyName();
$ceu['Department'] = $bsk->getDepartmentName();
$ceu['Office'] = $bsk->getOfficeNumber();
$ceu['Job title'] = $bsk->getProfession();
$ceu['Comment'] = $bsk->getComment();
$ceu['IM Address'] = $bsk->getIMAddress();
$ceu['Manager name'] = $bsk->getManagerName();
$ceu['Assistant name'] = $bsk->getAssistantName();
if ($cen || $cel) {
$cev = $cen . ($cen && $cel ? ", " : "") . $cel . " " . $cem;
}
else {
$cev = $ceo;
}
if ($cem || $ceq || $cer || $ces) {
$cfd = $cer . " " . $cel . " " . $cem;
$cfd .= ($ceq ? " '" . $ceq . "' " : " ") . $cen . " " . $ces;
}
$wd = $qp->getFullName();
}
else {
$ajp = true;
}
}
if (!$zd || !$aek) {
aeq('E_MESSAGE', $aek);
aer('contactFormatAsHTML', 'E_MESSAGE', "folder: " . $aek . "; uid: " . base_convert($zd, 10, 16));
}
$cev = $cep ? $cep : $ceo;
$cev = $cev ? $cev : $cen;
$aab = aa0($cev);
$dx = '<hr class="smallHR"><table border="0">'
. akc('<kerio:text id="contact-file-as"/>', aa0($cep))
. akc('<kerio:text id="contact-fullname"/>', aa0($cfd))
. akd()
. akc('<u><kerio:text id="contact-addr"/></u>');
foreach ($ceb as $ajk => $aoe) {
$aod = aa0($aoe['country']);
$aod = aa0($aoe['state']) . (($aod && $aoe['state']) ? " $aod" : $aod);
$aod = aa0($aoe['locality']) . (($aod && $aoe['locality']) ? "<br>$aod" : $aod);
$aod = aa0($aoe['zip']) . (($aod && $aoe['zip']) ? " $aod" : $aod);
$aod = nl2br(aa0($aoe['street'])) . (($aod && $aoe['street']) ? "<br>$aod" : $aod);
if ($ajk == "Home") $ajk = aaz('contact-home');
elseif ($ajk == "Business") $ajk = aaz('contact-business');
elseif ($ajk == "Other") $ajk = aaz('contact-other');
if (trim($aod) != '') $dx .= akc($ajk, $aod);
unset($aod);
}
$dx .= akd()
. akc('<u><kerio:text id="contact-phone-numbers"/></u>');
if (count($cdz) > 0) {
asort($cdz);
foreach ($cdz as $cea) {
$dx .= akc(ced($cea["type"]), aa0($cea['number']));
}
}
$dx .= akd()
. akc('<u><kerio:text id="contact-email"/></u>');
foreach ($aij as $anx) if ($anx['preferred'] == 1) $cj0[] = $anx;
foreach ($aij as $anx) if ($anx['preferred'] != 1) $cj0[] = $anx;
for ($az = 0; $az < count($cj0); $az++) {
$anx = $cj0[$az];
if (!empty($anx['address'])) {
$bi0 = ($az > 0) ? "E-mail $az" : "E-mail";
$dn = (strstr($anx['name'], ',')) ? '"' . $anx['name'] . '"' : $anx['name'];
$amm = (strlen($dn) > 0) ? '<' . $anx['address'] . '>' : $anx['address'];
$dx .= akc(aa0($bi0), aa0($dn) . ' ' . aa0($amm));
}
}
$dx .= akd();
foreach ($cet as $ajk => $chv) {
if (trim($chv) != '') $dx .= akc(cee($ajk), aa0($chv));
}
$ceu['Birthday'] = ($ceu['Birthday'] > 0) ? aan('%kdate', $ceu['Birthday']) : '';
$ceu['Anniversary'] = ($ceu['Anniversary'] > 0) ? aan('%kdate', $ceu['Anniversary']) : '';
foreach ($ceu as $bi0 => $ceh) {
if ($ceh != '') {
$cja = aa0($ceh);
switch ($bi0) {
case "Birthday": $bi0 = aaz('contact-birthday'); break;
case "Anniversary": $bi0 = aaz('contact-anniv'); break;
case "Company": $bi0 = aaz('contact-company'); break;
case "Department": $bi0 = aaz('contact-department'); break;
case "Office": $bi0 = aaz('contact-office'); break;
case "Job title": $bi0 = aaz('contact-jobtitle'); break;
case "Comment":
$cja = nl2br($cja);
$bi0 = aaz('contact-comment');
break;
case "IM Address": $bi0 = aaz('contact-im'); break;
case "Manager name": $bi0 = aaz('contact-manager'); break;
case "Assistant name": $bi0 = aaz('contact-assistant'); break;
}
$dx .= akc(stripslashes($bi0), $cja);
}
}
$dx .= '</table>';
return $dx;
}

function cjd($dn, $nr = NULL, $cjc = NULL) {
if (is_null($cjc)) {
$cjc = (is_null($nr));
}
if ($cjc) {
$cje = '<span class="dlistMemberItemCaption">';
$cjf = '</span>';
}
else {
$cje = '';
$cjf = '';
}

if (!is_null($nr)) {
return '<tr>'
. '<td align="left" valign="top"><nobr>' . $cje . $dn . ':&nbsp;' . $cjf . '</nobr></td>'
. '<td align="left" valign="top">' . $nr . '</td>'
. '</tr>';
}
else {
return '<tr><td colspan="2">' . $cje . $dn . $cjf . '</td></tr>';
}

}


function cjg(&$ans) {
foreach ($ans as $nr) {
if (!empty($nr)) return FALSE;
}
return TRUE;
}


function cjh(&$bsk) {

$cel = $bsk->getFirstName();
$cem = $bsk->getMiddleName();
$cen = $bsk->getSurName();
$ceo = $bsk->getCommonName();
$ceq = $bsk->getNickName();
$cer = $bsk->getTitleBefore();
$ces = $bsk->getTitleAfter();
$cep = $bsk->getFileAsName();

$cev = $cep;
if (empty($cev)) {
$cev = $ceo;
}
if (empty($cev)) {
$cev = $cen;
}

if (!empty($cem) || !empty($ceq) || !empty($cer) || !empty($ces)) {
$cfd = $cer . ' ' . $cel . ' ' . $cem;
$cfd .= ((!empty($ceq)) ? ' \'' . $ceq . '\' ' : ' ') . $cen . ' ' . $ces;
}
$cji = array();
$cji['firstName'] = $cel;
$cji['midName'] = $cem;
$cji['surName'] = $cen;
$cji['commonName'] = $ceo;
$cji['nickName'] = $ceq;
$cji['titleBefore'] = $cer;
$cji['titleAfter'] = $ces;
$cji['fileAsName'] = $cep;
$cji['displayName'] = $cev;
if (isset($cfd)) {
$cji['fullName'] = $cfd;
}
$cdz = $bsk->getPhoneNumbers(); $aij = $bsk->getEmailAddresses();
$ceb = array();
$ceb['Home'] = $bsk->getHomeAddress();
$ceb['Business'] = $bsk->getWorkAddress();
$ceb['Other'] = $bsk->getOtherAddress();
foreach ($ceb as $cek => $nr) { if (cjg($nr)) {
unset($ceb[$cek]);
}
}
$cet['Home'] = $bsk->getHomeUrl();
$cet['Business'] = $bsk->getWorkUrl();
$cet['Other'] = $bsk->getOtherUrl();
$cet['FreeBusy'] = $bsk->getFreeBusyUrl();
$cet['Calendar'] = $bsk->getCalendarUri();
foreach ($cet as $cek => $nr) {
if (empty($nr)) {
unset($cet[$cek]);
}
}
$ceu['Birthday'] = $bsk->getBirthDay();
$ceu['Anniversary'] = $bsk->getAnniversary();
$ceu['Company'] = $bsk->getCompanyName();
$ceu['Department'] = $bsk->getDepartmentName();
$ceu['Office'] = $bsk->getOfficeNumber();
$ceu['Job title'] = $bsk->getProfession();
$ceu['Comment'] = $bsk->getComment();
$ceu['IM Address'] = $bsk->getIMAddress();
$ceu['Manager name'] = $bsk->getManagerName();
$ceu['Assistant name'] = $bsk->getAssistantName();
foreach ($ceu as $cek => $nr) {
if (empty($nr)) {
unset($ceu[$cek]);
}
}
$dx = array('names' => &$cji, 'phones' => &$cdz, 'emails' => &$aij, 'addresses' => &$ceb,
'urls' => &$cet, 'other' => &$ceu);
return $dx;
}

function cjk(&$cjj) {
$cji =& $cjj['names'];
$cdz =& $cjj['phones'];
$aij =& $cjj['emails'];
$ceb =& $cjj['addresses'];
$cet =& $cjj['urls'];
$ceu =& $cjj['other'];
$cjl = "<tr><td colspan=\"2\">&nbsp;</td></tr>\n";
$cjm = TRUE;
$dx = '<table class="dlistMemberTable">';
$dx .= '<tr class="dlistMemberCaption"><td colspan="2">' . cej(aa0($cji['displayName'])) . '&nbsp;</td></tr>';
if (!empty($cji['fullName'])) {
$dx .= cjd('<kerio:text id="contact-fullname"/>', cej(aa0($cji['fullName'])));
$cjm = FALSE;
}
if (!empty($ceb)) {
if (!$cjm) {
$dx .= $cjl;
$cjm = FALSE;
}
$dx .= cjd('<kerio:text id="contact-addr"/>');
$cjn = array('Home'=>'contact-home', 'Business'=>'contact-business', 'Other'=>'contact-other');
foreach ($ceb as $ajk => $cjo) {
$cjp = $cjn[$ajk];
$cjq = cej(aa0($cjo['country']));
$cjq = cej(aa0($cjo['state'])) . (($cjq && $cjo['state']) ? ' ' . $cjq : $cjq);
$cjq = cej(aa0($cjo['locality'])) . (($cjq && $cjo['locality']) ? ', ' . $cjq : $cjq);
$cjq = cej(aa0($cjo['zip'])) . (($cjq && $cjo['zip']) ? ' ' . $cjq : $cjq);
$cjq = cej(aa0($cjo['street'])) . (($cjq && $cjo['street']) ? ', ' . $cjq : $cjq);
$dx .= cjd(aaz($cjp), $cjq);
} } if (!empty($cdz)) {
if (!$cjm) {
$dx .= $cjl;
$cjm = FALSE;
}
$dx .= cjd('<kerio:text id="contact-phone-numbers"/>');
asort($cdz);
foreach ($cdz as $cjs) {
$dx .= cjd(ced($cjs["type"]), cej(aa0($cjs['number'])));
}
} if (!empty($aij)) {
if (!$cjm) {
$dx .= $cjl;
$cjm = FALSE;
}
$cjt = count($aij);
if ($cjt > 1) { $dx .= cjd('<kerio:text id="contact-email"/>');
$cju = 1;
foreach ($aij as $amm) {
if (!empty($amm['address'])) { $bi0 = "E-mail " . $cju;
$dn = (strpos($amm['name'], ',') !== FALSE) ? '"' . $amm['name'] . '"' : $amm['name'];
$amm = (!empty($dn)) ? '<' . $amm['address'] . '>' : $amm['address'];
$dx .= cjd($bi0, cej(aa0($dn)) . ' ' . cej(aa0($amm)));
$cju++;
}
} }
else {
$amm = $aij[0];
if (!empty($amm['address'])) { $bi0 = '<kerio:text id="contact-email"/>';
$dn = (strpos($amm['name'], ',') !== FALSE) ? '"' . $amm['name'] . '"' : $amm['name'];
$amm = (!empty($dn)) ? '<' . $amm['address'] . '>' : $amm['address'];
$dx .= cjd($bi0, cej(aa0($dn)) . ' ' . cej(aa0($amm)), TRUE);
}
} } if (!empty($cet)) {
if (!$cjm) {
$dx .= $cjl;
$cjm = FALSE;
}
foreach ($cet as $ajk=>$chv) {
$dx .= cjd(cee($ajk), cej(aa0($chv)));
}
}
if (!empty($ceu)) {
if ((!$cjm) && empty($cet)) { $dx .= $cjl;
$cjm = FALSE;
}
if (!empty($ceu['Birthday'])) {
$ceu['Birthday'] = aan('%kdate', $ceu['Birthday']);
}
if (!empty($ceu['Anniversary'])) {
$ceu['Anniversary'] = aan('%kdate', $ceu['Anniversary']);
}
$cjv = array(
'Birthday' => 'contact-birthday',
'Anniversary' => 'contact-anniv',
'Company' => 'contact-company',
'Department' => 'contact-department',
'Office' => 'contact-office',
'Job title' => 'contact-jobtitle',
'Comment' => 'contact-comment',
'IM Address' => 'contact-im',
'Manager name' => 'contact-manager',
'Assistant name' => 'contact-assistant'
);
foreach ($ceu as $bi0 => $ceh) {
$bi0 = aaz($cjv[$bi0]);
$dx .= cjd(stripslashes($bi0), cej(aa0($ceh)));
}
} $dx .= '</table>';
return $dx;
}

function cjx(&$cjw) {
$cjy = $cjw->getDlist();
$cjy = cjz($cjy);
$ck0 = $cjw->getCommonName();
$dx = '<table class="dlistMemberTable">'
. '<tr class="dlistMemberCaption"> <td style="width:100%">' . cej(aa0($ck0))
. '</td><td><img src="' . DLIST_ICON_PRINT . '"></td></tr></table>';
$dx .= '<table class="dlistMemberTable">';
foreach($cjy as $cka) {
if ($cka['isDList']) {
$dx .= cjd(cej(aa0($cka['name'])) . '&nbsp;<img src="' . DLIST_ICON_PRINT . '">', NULL, FALSE);
}
else {
$dx .= cjd(cej(aa0($cka['name'])), cej(aa0($cka['address'])));
}
}
$dx .= '</table>';
return $dx;
}

function ckc(&$ckb) {
$dx = '<table class="dlistMemberTable">'
. '<tr class="dlistMemberCaption"><td colspan="2">' . cej(aa0($ckb['name'])) . '&nbsp;</td></tr>';
$dx .= cjd('<span class="dlistMemberItemCaption"><kerio:text id="contact-email"/></span>',
cej(aa0($ckb['address'])));
$dx .= '</table>';
return $dx;
}

function ckd($aek, $zd, &$aab) {
global $ak;
$abi = $ak->getFolderStore();
$cke = $abi->openContactFolder($aek); if (is_null($cke)) {
aeq('E_FOLDER_OPEN');
aer('dlistFormatAsHTML', 'E_FOLDER_OPEN', "folder: " . $aek);
}
$ckf = $cke->readContact($zd);
if (is_null($ckf)) {
aeq('E_DLIST_OPEN');
aer('dlistFormatAsHTML', 'E_DLIST_OPEN', "folder: " . $aek . "; uid: " . base_convert($zd, 10, 16));
}
unset($cke); $ckg = $ckf->copy();
unset($ckf);
$ckg->updateDListReferences($ak);
$ckh = $ckg->getCommonName();
$aab = aa0($ckh);
$dx = '<table width="100%;">';
$cki = $ckg->getDlist();
$ckj = count($cki);
$ckk = array();
for ($ckl = 0; $ckl < $ckj; $ckl ++) {
$cka =& $cki[$ckl];
if ($cka['type'] != KMS_DLREFERENCE) {
unset($cka);
continue;
}
$ckm = $cka['referencePath'];
if (!isset($ckk[$ckm])) {
$ckk[$ckm] = array();
}
$ckk[$ckm][] =& $cki[$ckl];
}
foreach ($ckk as $ckm=>$ckn) {
$aed = $abi->guidToFolderPath($ckm);
$cke = $abi->openContactFolder($aed);
if (is_null($cke)) {
continue;
}
$cko = count($ckn);
for ($ckl = 0; $ckl < $cko; $ckl++) {
$cjw = $cke->readContact($ckn[$ckl]['referenceUid']);
if (is_null($cjw)) {
continue;
}
$ckn[$ckl]['contactObj'] =& $cjw;
unset($cjw);
}
unset($cke);
} $cki = cjz($cki);
for ($ckl = 0; $ckl < $ckj; $ckl ++) {
$ckp = (($ckl % 2) == 0);
if ($ckp) { $dx .= '<tr><td class="dlistMemberCell">';
}
else { $dx .= '<td class="dlistMemberCell">';
}
$cka =& $cki[$ckl]; switch ($cka['type']) {
case KMS_DLSIMPLE: case KMS_DLOPAQUE; $dx .= ckc($cka);
break;
case KMS_DLREFERENCE: if (!empty($cka['contactObj'])) { if ($cka['isDList']) {
$dx .= cjx($cka['contactObj']);
}
else {
$cjj = cjh($cka['contactObj']);
$dx .= cjk($cjj);
unset($cjj);
}
}
else { $dx .= ckc($cka);
}
break;
} unset($cka); if ($ckp) {
$dx .= '</td>';
}
else {
$dx .= "</td></tr>\n";
}
} if (($ckj % 2) != 0) {
$dx .= '<td class="dlistMemberCell">&nbsp;</td></tr>';
}
$dx .= '</table>';
return $dx;
}

function cjz($ckn) {
global $n0;
$ckq = array(); $ckr = array(); foreach ($ckn as $abt) {
$ckq[$abt['name']] = $abt;
$ckr[] = $abt['name'];
}
kerio_sort($n0, $ckr);
$cks = array();
foreach ($ckr as $ckt) {
$cks[] =& $ckq[$ckt];
}
return $cks;
}

function cku($cjw) {
$ckv = aaz('dlist');
$cki = $cjw->getDlist();
$ckw = aa0($cjw->getCommonName());
$dx = '<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">'
. ' <html> <head> <meta http-equiv="Content-type" content="text/html; charset=utf-8"> </head> '
. ' <body style="font: 12px Verdana, Arial, sans-serif">';
$dx .= '<h3>' . $ckw . "</h3>\n";
$dx .= "<table><col style='padding-right:12px'>\n";
foreach ($cki as $cka) {
if ($cka['isDList']) {
$ckx = '<span style="color:gray">' . $ckv . '</span>';
}
else {
$ckx = '<a href="mailto:' . aa0($cka['address']) . '">' . aa0($cka['address']) . '</a>';
}
$dx .= '<tr><td>' . aa0($cka['name']) . '</td><td>' . $ckx . "</td></tr>\n";
}
$dx .= "</table>\n";
$cky = $cjw->getComment();
if ($cky != '') {
$dx .= '<br>' . aa0($cky);
}
$dx .= '</body></html>';
return $dx;
}

function ckz($cjw) {
$dx = $cjw->getCommonName() . "\n\n";
$cki = $cjw->getDlist();
foreach ($cki as $cka) {
$dx .= $cka['name'] . "\t" . $cka['address'] . "\n";
}
$cky = $cjw->getComment();
if ($cky != '') {
$dx .= "\n" . $cky;
}
return $dx;
}

function cgg($ala) {
echo "aff.agj();\n";
echo "aff.ahh('');\n";
echo "aff.aov('" . aow($ala) . "', 'mainContent');\n";
echo "aff.cft();\n";
echo "aff.document.getElementById('frameMainHeader').style.display = '';\n";
}
?>
