<?php


function csx($het) {
switch ($het) {
case FLD_INBOX: return kerio_translate($_SESSION['lang'], "fld-inbox");
case FLD_SENT: return kerio_translate($_SESSION['lang'], "fld-sent");
case FLD_DRAFT: return kerio_translate($_SESSION['lang'], "fld-drafts");
case FLD_JUNK: return kerio_translate($_SESSION['lang'], "fld-junk");
case FLD_TRASH: return kerio_translate($_SESSION['lang'], "fld-trash");
case FLD_CONTACT: return kerio_translate($_SESSION['lang'], "fld-contacts");
case FLD_CALENDAR: return kerio_translate($_SESSION['lang'], "fld-calendar");
case FLD_TODO: return kerio_translate($_SESSION['lang'], "fld-tasks");
case FLD_PUBLIC: return kerio_translate($_SESSION['lang'], "fld-public");
case FLD_ARCHIVE: return kerio_translate($_SESSION['lang'], "fld-archive");
}
return kerio_convert("utf-7m", "utf-8", $het);
}

function hpp($het, $hpo) {

if ($hpo == WME_SUBSCRIBED_FOLDER) $het = substr(strstr($het, "/~"), 1);

foreach (array(FLD_INBOX, FLD_CONTACT, FLD_SENT, FLD_DRAFT, FLD_JUNK, FLD_TRASH, FLD_PUBLIC, FLD_ARCHIVE, FLD_CALENDAR, FLD_TODO) as $aoe) {
if (strstr($het, "/") == "/" . $aoe) return true; }
return false;
}




function dky($ak, $hpq, $hff, $dfq) {

if ($hff == "") return false;

if (ereg('\\|\/|\*|\?|\"|\<|\>|\||\:', $hff)) { hhd(1401, "invalid character"); return false;
}
elseif (strlen($hff) > 512) { hhd(1401, "too long folder name"); return false;
}
$abi = $ak->getFolderStore();
if ($abi->createFolder($hpq . "/" . $hff, $dfq) != 0) {
hhd(1401, array($hpq, $hff)); return false;
}
return true;
}

function dkq($ak, $dkn, $dkk, $dil = "") {
if ($dkk == "" || $dkn == $dkk || hpp($dkn, WME_MY_FOLDER)) return false;
if (ereg('\\|\/|\*|\?|\"|\<|\>|\||\:', $dil)) { hhd(1411, "invalid character"); return false;
}
elseif (strlen($dil) > 512) { hhd(1411, "too long folder name"); return false;
}

$abi = $ak->getFolderStore();

if ($abi->renameFolder($dkn, $dkk) != 0) {
hhd(1411, array($dkn, $dkk)); return false;
}
return true;
}




function dku($ak, $het) {

if (hpp($het, WME_MY_FOLDER)) return false;

$abi = $ak->getFolderStore();

if ($abi->deleteFolder($het, true) != 0) {
hhd(1421, $het); return false;
}
return true;
}




function dki($ak, $dkg, $dkh) {

$abi = $ak->getFolderStore();

$het = $dkh . strrchr($dkg, "/");
$dkk = $het;
$dkl = 1;

while ($abi->folderExists($dkk)) {
$dkk = $het . $dkl++;
}
return $dkk;
}




function hfg($ak) {

$abm = $ak->getMyUserInfo();
$het = "~" . $abm->getUserName() . "/" . FLD_TRASH . "/" . FLD_CONTACT;
$abi = $ak->getFolderStore();

$abo = $abi->openFolder($het, FLD_CONTACT);
if (is_null($abo)) {
if ($abi->createFolder($het, KMS_FCONTACT) != 0) return "";
}

return $het;
}




function hgq($nr, $ajk) {

switch ($ajk) {

case 'U':
$dha = explode('@', $nr);
$dnh = count($dha);

switch ($dnh) {
case 1:
$hpr = kerio_is_valid_username($nr);
break;

case 2:
$hpr = (kerio_is_valid_username($dha[0]) && kerio_is_valid_domainname($dha[1]));
break;

default:
$hpr = false;
break;
}
if (!$hpr) {
$_SESSION['warning']['txt'] = '<kerio:text id="alert-invalid-username-or-email"/>';
return false;
}
break;

case 'G':
if (preg_match('/[@,\[\]]/', $nr)) {
$_SESSION['warning']['txt'] = '<kerio:text id="alert-invalid-group"/>';
return false;
}
break;

case 'D':
if (!kerio_is_valid_domainname($nr)) {
$_SESSION['warning']['txt'] = '<kerio:text id="alert-invalid-domain"/>';
return false;
}
break;
}
return true;
}




function hgs($ak, $het, $wd, $dlg) {

if ($het == "" || $wd == "") {
return;
}
$abi = $ak->getFolderStore();

if ($dlg == WME_REMOVE_ALL_RIGHTS) {

foreach ($wd as $qp) {
$cdu = $abi->deleteFolderAcl($het, $qp);
}
}
else {

if ((strpos($wd, "@") === false && $wd != "anyone" && $wd != "authuser") || ($wd == "authuser@")) {
$abm = $ak->getMyUserInfo();
$hps = $abm->getUserName();
$wd = ($wd == "authuser@" ? "authuser" : $wd) . strstr($hps, "@");
}

if ($wd == $hps) return;

if (!$abi->setFolderAcl($het, $wd, ($dlg == "R" ? "lr" : ($dlg == "E" ? "lrswid" : "lrswicda")))) {
hhd(1451, array($het, $wd, $dlg));
}
}
}




function hgt($ak, $wd) {

if ($wd == "") return false;

$hpt = false;
$hpu = 0;

if (strpos($wd, "@") === false) {
$abm = $ak->getMyUserInfo();
$wd .= strstr($abm->getUserName(), "@");
}

if (substr($wd, 0, 1) !== "~") $wd = "~" . $wd;

$abi = $ak->getFolderStore();
$cis = $abi->listFolders($wd . "/*", KMS_FANY, 0);
$hpv = $abi->getSharedFolderMappings();

foreach ($cis as $abo) {

if ($abo['type'] != KMS_FMAIL && $abo['type'] != KMS_FCONTACT) continue;

$hpu++;

if ((in_array($abo['name'], $hpv)) === false) {
if (!$abi->mapSharedFolder($abo['name'])) $hpt = true;
}
}

if ($hpt) hhd(1461, $wd);

return $hpu;
}




function hgv($ak, $het, $hpw) {

$abi = $ak->getFolderStore();

if ($hpw) {
$cis = $abi->listFolders($het . "/*", KMS_FANY, 0);
if (count($cis)) foreach ($cis as $abo) {
$abi->unmapSharedFolder($abo['name']);
}
}
else {
$abi->unmapSharedFolder($het);
}
}




function hgu($ak, $wd) {

$abm = $ak->getMyUserInfo();
$hpx = $abm->getUserName();

if (strpos($wd, "@") === false) $wd.= strstr($hpx, "@");

$abi = $ak->getFolderStore();
$cis = $abi->listFolders("~" . $hpx . "/~" . $wd . "/*", KMS_FANY, 0);

foreach ($cis as $abo) {
if ($abo['isSelectable'] && ($abo['type'] == KMS_FMAIL || $abo['type'] == KMS_FCONTACT)) return $abo['name'];
}
return "";
}




function hdu($ak) {

$abi = $ak->getFolderStore();
$abm = $ak->getMyUserInfo();
$cis = $abi->listFolders("~" . $abm->getUserName() . "/*", KMS_FANY, 0); 
$hpy = $abi->getSharedFolderMappings();

$dhd = "";
foreach ($cis as $abo) {

$dhd[] = array(
'name' => $abo['name'],
'nameLocal' => "", 'subList' => substr_count($abo['name'], "/") - 1, 'rights' => ($abo['isShared'] ? "S" : (strpos($abo['myRights'], "a") !== false ? "A" : (strpos($abo['myRights'], "d") !== false ? "E" : "R"))), 'type' => ($abo['isSelectable'] ? $abo['type'] : WME_NOT_SELECTABLE),
'unseen' => ($abo['isSelectable'] ? ($abo['messageUnseenCount'] ? "(" . $abo['messageUnseenCount'] . ")" : "") : ""),
'total' => $abo['messageCount']);
}

$dnh = count($dhd); $hpz = $dhd[$dnh - 1]['name'];

for ($az = $dnh - 1; $az >= 0; $az--) {

$dhd[$az]['display'] = (strpos($hpz . "/", $dhd[$az]['name'] . "/") !== false ? WME_CLOSED_SUBFOLDERS : WME_NO_SUBFOLDERS); 
if ($dhd[$az]['type'] == KMS_FMAIL || $dhd[$az]['type'] == KMS_FCONTACT) {
$hpz = $dhd[$az]['name']; }

elseif (in_array(substr(strstr($dhd[$az]['name'], "/"), 1), $hpy) && ($cis[$az]['type'] == KMS_FMAIL || $cis[$az]['type'] == KMS_FCONTACT)) {
$dhd[$az]['type'] = WME_NOT_ACCESSIBLE;
}

elseif (strpos($hpz . "/", $dhd[$az]['name'] . "/") === false) {
$dhd[$az]['nameLocal'] = "-1"; }

else {
$dhd[$az]['type'] = WME_NOT_SELECTABLE;
}
}

$az = $dnh - 1;
while ($az > 1 && $cis[$az]['type'] != KMS_FMAIL && $cis[$az]['type'] != KMS_FCONTACT) {
$dhd[$az]['nameLocal'] = -1;
$az--;
}

$dhd[$az]['display'] = WME_NO_SUBFOLDERS; 
$hdt = ""; $hq0 = 0;
foreach ($dhd as $hgc) {
if ($hgc['nameLocal'] == "") {

$hqa = explode("/", $hgc['name']);
$hqa[0] = ""; $dnh = count($hqa);

if ($hqa[1] == FLD_PUBLIC && $hqa[2] != "" || $hqa[1] == FLD_TRASH && $hqa[2] == FLD_CONTACT) {
$hqa[1] = csx($hqa[1]); $hqa[2] = csx($hqa[2]); $cek = 3;
}
else {
$cek = min($dnh - 1, (substr($hqa[1], 0, 1) != "~" ? 1 : 2)); $hqa[$cek] = csx($hqa[$cek]); $cek++;
}

for ($az = $cek; $az < $dnh; $az++) $hqa[$az] = kerio_convert("utf-7m", "utf-8", $hqa[$az]);

$hgc['nameLast'] = aa0($hqa[$dnh - 1]); $hgc['shortLast'] = aa0(hlc($hqa[$dnh - 1], FLD_OUTPUT_LENGTH));

if ($_SESSION['pda'] == 0) {


$hdh = substr(implode(" : ", $hqa), 3);

if ($hgc['subList'] > 0) {

$ha0 = mb_strlen($hdh);
if ($ha0 > 2 * 20 + 3) {
$ha0 = ceil(2 * 20 / ($dnh - 1));

for ($az = 1; $az < $dnh; $az++) if (mb_strlen($hqa[$az]) > $ha0) $hqa[$az] = mb_substr($hqa[$az], 0, $ha0) . "...";

$hdh = substr(implode(" : ", $hqa), 3);
}
}

$hgc['nameLocal'] = aa0($hdh, ENT_QUOTES); }

else {
$ha0 = (strpos($hqa[$dnh - 1], "<kerio:text") !== false ? -1 : mb_strlen($hqa[$dnh - 1]));
if ($ha0 > 15) {
$hqa[$dnh - 1] = mb_substr($hqa[$dnh - 1], 0, 12) . "...";
}
$ahj = "";
for ($az = 2; $az < $dnh; $az++) $ahj .= "- ";
$hgc['nameLocal'] = $ahj . aa0($hqa[$dnh - 1]); }
$hdt[($hgc['name'] == $_SESSION['fld'] ? WME_CURRENT_FOLDER : $hq0++)] = $hgc; }
}

if ($_SESSION['pda'] == 0) {

$hqb = array();

foreach ($hdt as $hgc) {

$dn = $hgc['name'];
$hqc = $hgc['nameLocal'];

$hqb[$dn] = $hqc; 
$hnw = explode("/", $dn);
$hqd = explode(" : ", $hqc);
$dnh = count($hnw);

$hqe = $hnw[0];
$hqf = $hqd[0];

for ($az = 1; $az < $dnh; $az++) {

$hqe .= "/" . $hnw[$az]; if (mb_strlen($hqb[$hqe]) > mb_strlen($hqf)) $hqb[$hqe] = $hqf; $hqf .= " : " . $hqd[$az]; }
}

foreach ($hdt as $bwj => $hgc) {

if ($hdt[$bwj]['subList'] > 0) { $dni = mb_substr($hdt[$bwj]['name'], 0, strrpos($hdt[$bwj]['name'], "/")); $hdt[$bwj]['nameLocal'] = $hqb[$dni] . " : " . $hdt[$bwj]['shortLast']; }
elseif ($hdt[$bwj]['subList'] == 0) {
$hdt[$bwj]['nameLocal'] = $hdt[$bwj]['shortLast']; }
}
}

foreach ($hdt as $bwj => $hgc) {
foreach (array('nameLocal', 'nameLast', 'shortLast') as $bsq) {
$hdt[$bwj][$bsq] = str_replace("  ", " &nbsp;", $hdt[$bwj][$bsq]);
}
}

return $hdt;
}




function hdw($hdt, $aed) {

if (!is_array($hdt)) return "";

$az = 0;
$dhd = array();
foreach ($hdt as $hgc) {
$bwj = ($hgc['name'] != $aed ? $az++ : WME_CURRENT_FOLDER);
$dhd[$bwj] = $hgc;
}

return $dhd;
}




function hdp($ak, $hqg, $het, $dkk = "") {

$abm = $ak->getMyUserInfo();
$agi = $abm->getSettings();

$hqh = explode("|", $agi['toggledFld']); 
switch ($hqg) {
case WME_RENAME_FOLDER:

$hdh = "";
if (is_array($hqh)) foreach ($hqh as $hqi) {
$hdh[] = str_replace($het, $dkk, $hqi);
}
$hqh = $hdh;
break;

case WME_PACK_FOLDER:

$hdh = "";
if (is_array($hqh)) foreach ($hqh as $hqi) {
if ($hqi != $het) $hdh[] = $hqi; }
$hqh = $hdh;
break;

case WME_UNPACK_FOLDER:

if (array_search($het, $hqh) === false) $hqh[] = $het;
break;

case WME_UNPACK_ALL_FOLDERS:

$hdh = explode("/", $het);
$dnh = count($hdh);
$ciu = $hdh[0];

for ($az = 1; $az < $dnh; $az++) {
$ciu .= "/" . $hdh[$az];

if (array_search($ciu, $hqh) === false) $hqh[] = $ciu;
}
break;
}

$agi['toggledFld'] = implode("|", $hqh);
if (!$abm->saveSettings($agi)) hhd(1431);
}




function hjs($ak, $hdt) {

$abm = $ak->getMyUserInfo();
$agi = $abm->getSettings();
$wd = $abm->getUserName();

switch ($hdt[WME_CURRENT_FOLDER]['type']) {
case KMS_FMAIL: $cfl = "browse.php"; break;
case KMS_FCONTACT: $cfl = "contact.php"; break;
default: $cfl = ""; break;
}
?>
	<table cellspacing='0' cellpadding='2' border='0' xwidth='100%' class='menuTable'>
	<tr class='head'>
		<td nowrap align='left'>
			<kerio:text id='main-folders'/>
			<span class='bracket'>[&nbsp;<a href='folder.php'><kerio:text id='express-admin-on'/></a>&nbsp;]</span>
		</td>
	</tr>
	<tr class='tree'>
		<td nowrap class='topMargin'>
			<img src='/default/gfx/user.gif' width='16' height='16' alt='*' title=''>

			<a href='quota.php'>
			<?php
 print
($_SESSION['fld'] !== "" ? "" : "<b class='actFolder'>") .
(mb_strlen($wd) > USERNAME_LENGTH + 3 ? mb_substr($wd, 0, USERNAME_LENGTH) . "..." : $wd) .
($_SESSION['fld'] !== "" ? "" : "</b>")
?>
			</a>&nbsp;
		</td>
	</tr>
	<tr class='tree'>
		<td valign='top' nowrap>
		<ul class='firstUl'>

		<?php
 $hqj = 0;
$dev = "";
$hqk = 0; $hqh = explode("|", $agi['toggledFld']); 
foreach ($hdt as $bwj => $hgc) {

if ($hgc['subList'] == 0 || ($hgc['subList'] <= $hqk && array_search(substr($hgc['name'], 0, strrpos($hgc['name'], "/")), $hqh) !== false)) {

$hqk = $hgc['subList'] + 1; 
for ($alh = $hqj; $alh < $hgc['subList']; $alh++) {
$dev .= "<ul>";
}
for ($alh = $hgc['subList']; $alh < $hqj; $alh++) {
$dev .= "</ul>";
}
$hqj = $hgc['subList'];

if ($bwj === WME_CURRENT_FOLDER) {
$him = "<b class='actFolder'>"; $hin = "</b>";
}
else {
$him = $hin = "";
}

$dev .= "<li>";

if ($hgc['display'] != WME_NO_SUBFOLDERS && array_search($hgc['name'], $hqh) !== false) $hgc['display'] = WME_OPENED_SUBFOLDERS;

switch ($hgc['display']) {
case WME_CLOSED_SUBFOLDERS:
$dev .= "<a href='" . $cfl . "?actionn=folderMinus&rand=" . $_SESSION['rand'] . "&pmFld=" . urlencode($hgc['name']) . "'><img src='/default/gfx/plus.gif' width='16' height='16' border='0' alt='+' title=''></a>";
$hql = $hgc['subList']; break;
case WME_OPENED_SUBFOLDERS:
$dev .= "<a href='" . $cfl . "?actionn=folderPlus&rand=" . $_SESSION['rand'] . "&pmFld=" . urlencode($hgc['name']) . "'><img src='/default/gfx/minus.gif' width='16' height='16' border='0' alt='-' title=''></a>";
break;
case WME_NO_SUBFOLDERS:
$dev .= "<img src='/default/gfx/trpix.gif' width='16' height='16'>";
$hql = $hgc['subList']; break;
}

switch ($hgc['type']) {
case KMS_FMAIL:
$hqm = (strstr($hgc['name'], "/") == "/" . FLD_INBOX ? "fmail_yellow" : (strstr($hgc['name'], "/") == "/" . FLD_TRASH ? "ftrash" : "fmail"));
$hqn = false;
$hqo = true;
$hqp = "browse.php?actionn=browseSearchOff&rand=" . $_SESSION['rand'] . "&";
break;

case KMS_FCONTACT:
$hqm = "fcontact";
$hqn = false;
$hqo = true;
$hqp = "contact.php?actionn=contactSearchOff&rand=" . $_SESSION['rand'] . "&";
break;

case WME_NOT_ACCESSIBLE:
$hqm = "folder_gray"; $hqo = false;
break;

default:
$hqm = "folder";
$hqn = true;
$hqo = ($hgc['type'] != WME_NOT_SELECTABLE && ($hgc['rights'] == "A" || $hgc['rights'] == "S"));
$hqp = "browse.php?";
break;
}
$aed = ($hgc['shortLast'] == $hgc['nameLast'] ? $hgc['nameLast'] : "<span title='" . $hgc['nameLast'] . "'>" . $hgc['shortLast'] . "</span>");

$dev .=
($hqo ? "<a href='" . $hqp . "fld=" . urlencode($hgc['name']) . ($hqn ? "" : "&pag=0") . "'>" : "") .
"<img src='/default/gfx/" . $hqm . ($hgc['rights'] == "S" ? "s" : "") . ".gif' width='16' height='16' border='0'>&nbsp;" .
$him . $aed . "&nbsp;". $hgc['unseen'] . $hin .
($hqo ? "</a>" : "") . "</li>\n";
}
}
for ($az = 0; $az < $hql; $az++) $dev .= "</ul>";
print $dev;
?>
		</ul>
		</td>
	</tr>
	</table>
	<?php
}




function hju($ak, $hdt) {

switch ($hdt[WME_CURRENT_FOLDER]['type']) {
case KMS_FMAIL: $cfl = "browse.php"; $hqq = 'browseGo'; break;
case KMS_FCONTACT: $cfl = "contact.php"; $hqq = 'contactGo';break;
default: return;
}
$abm = $ak->getMyUserInfo();
$wd = $abm->getUserName();

$hma = ($_SESSION['pda'] == 0 ? USERNAME_LENGTH : PDA_USERNAME_LENGTH);

$dev =
"<table cellpadding='0' cellspacing='2' border='0'>" .
"<tr><td nowrap>" .

"<input type='hidden' name='adm' value='0'>" .
"<select name='fld' id='fldCombox'>" .
"<option value='root'>" .
(mb_strlen($wd) > $hma + 3 ? mb_substr($wd, 0, $hma) . "..." : $wd) .
"</option>";

foreach ($hdt as $bwj => $hgc) {

if ($hgc['type'] != KMS_FMAIL && $hgc['type'] != KMS_FCONTACT) continue;

$dev .=
"<option " . ($bwj === WME_CURRENT_FOLDER ? "selected " : "") .
"value='" . ($hgc['type'] != $hdt[WME_CURRENT_FOLDER]['type'] ? "!" : "") . aa0($hgc['name']) . "'>" . $hgc['nameLocal'] . ($hgc['unseen'] != "" ? " " : "") . $hgc['unseen'] .
"</option>";
}

print $dev .
"</select>&nbsp;".
"<input id='goButton' type='submit' name='" . $hqq . "' value='<kerio:text id='express-go'/>'>" .
($_SESSION['fld'] !== "" && $_SESSION['pda'] == 0 ?
"<td><span class='bracket'>&nbsp;[&nbsp;<a href='folder.php'><kerio:text id='express-admin-on'/></a>&nbsp;]</span></td>" : "") .
"</td></tr></table>";
}




function hek($hdt) {
$dev = " <span id='newFld'><select name='newFld'>";
foreach ($hdt as $hgc) {
if ($hgc['type'] != $hdt[WME_CURRENT_FOLDER]['type']) continue; if ($hgc['rights'] == "R") continue; $dev .= "<option" . ($_SESSION['prevFolder'][$hgc['type']] == $hgc['name'] ? " selected" : "") . " value='" . aa0($hgc['name']) . "'>" . $hgc['nameLocal'] . "</option>";
}
print $dev;
$d = ($hdt[WME_CURRENT_FOLDER]['rights'] != "R" ? "detailMove" : "detailCopy");
?>
</select>
</span><input id='ok' name='<?php print $d?>' type='submit' value='<kerio:text id='common-ok'/>'>
</td>
</tr>
</table><?php
}

function hgw($ak, $hdt) {
$abm = $ak->getMyUserInfo();
$abi = $ak->getFolderStore();
$hpy = $abi->getSharedFolderMappings();

$hpz = $bvk = "";
foreach ($hpy as $dje) {
if (($hdh = substr($dje, 0, strpos($dje, "/"))) != $hpz) $bvk['users'][] = $hpy[] = $hpz = $hdh;
}

foreach ($hdt as $hgc) {
$bvk[$hgc['name']] = (in_array(substr(strstr($hgc['name'], "/"), 1), $hpy) ? WME_SUBSCRIBED_FOLDER : WME_MY_FOLDER);
}

return $bvk;
}




function hgx($ak, $hdt, $bvk) {

$abm = $ak->getMyUserInfo();
$wd = $abm->getUserName();

$hqr = ($_SESSION['pda'] == 0 ? "&nbsp;" : ""); ?>

	<table cellspacing='0' cellpadding='2' border='1' width='100%' class='folderTable' id='folderTable'>

	<?php if ($_SESSION['pda'] == 0) :?>

	<tr class='head'>
		<td width='60%'><kerio:text id='common-folder'/></td>
		<td width='1%'><kerio:text id='contact-list-items'/></td>
		<td width='1%'><kerio:text id='express-action'/></td>
		<td><kerio:text id='express-sharing'/></td>
	</tr>

	<tr>
		<td nowrap><img src='../default/gfx/user.gif' width='16' height='16' alt='*' title=''> <a href='quota.php' class='folder'>
		<?php
 print (mb_strlen($wd) > USERNAME_LENGTH + 3 ? "<span title='" . aa0($wd) . "'>" . mb_substr($wd, 0, USERNAME_LENGTH) . "...</span>" : $wd);
?>
		</a></td>
		<td align='right'>&nbsp;</td>
		<td><a href='folder.php?goto=folderCreate&root=1'><kerio:text id='express-new-folder'/></a></td>
		<td nowrap><a href='folder.php?goto=folderSubscribe'><kerio:text id='express-subscribe'/></a></td>
	</tr>

	<?php else: ?>

	<tr>
		<td width='1%'><img src='../default/gfx/user.gif' width='16' height='16' alt='*' title=''></td>
		<td>
			<a href='quota.php' class='folder'>
			<?php
 print (mb_strlen($wd) > PDA_USERNAME_LENGTH + 3 ? mb_substr($wd, 0, PDA_USERNAME_LENGTH) . "..." : $wd);
?>
			</a><br>
			<a href='folder.php?goto=folderCreate&root=1'><kerio:text id='express-new-folder'/></a> - <a href='folder.php?goto=folderSubscribe'><kerio:text id='express-subscribe'/>
		</td>
	</tr>

	<?php endif; ?>

	<?php

$dev = "";

$hqs = ($_SESSION['pda'] == 0 ? 2 : 1);

foreach ($hdt as $bwj => $hgc) {

$ps = "";

if ($hgc['type'] != WME_NOT_SELECTABLE && $hgc['type'] != WME_NOT_ACCESSIBLE) {
switch ($hgc['type']) {
case KMS_FMAIL:
$hqm = (strstr($hgc['name'], "/") == "/" . FLD_INBOX ? "fmail_yellow" : (strstr($hgc['name'], "/") == "/" . FLD_TRASH ? "ftrash" : "fmail"));
break;

case KMS_FCONTACT:
$hqm = "fcontact";
break;

default:
$hqm = "folder";
break;
}

if ($hgc['rights'] == "A" || $hgc['rights'] == "S") {
$d = "<a href='folder.php?goto=folderCreate&fld=" . urlencode($hgc['name']) . "'><kerio:text id='express-new-subfolder'/></a>";
if (!hpp($hgc['name'], $bvk[$hgc['name']])) {

$d .=
" - <a href='folder.php?goto=folderRename&fld=" . urlencode($hgc['name']) . "'><kerio:text id='express-rename'/></a>" .
" - <a href='folder.php?goto=folderMove&fld=" . urlencode($hgc['name']) . "'><kerio:text id='express-move'/></a>" .
" - <a href='folder.php?goto=folderDelete&rand=" . $_SESSION['rand'] . "&fld=" . urlencode($hgc['name']) . "&fldType=" . $hgc['type'] . "' name='del'><kerio:text id='express-delete'/></a>"; }

$hqt = ($bvk[$hgc['name']] ? "<a href='folder.php?goto=folderUnsubscribe&rand=" . $_SESSION['rand'] . "&fld=" . urlencode($hgc['name']) . "' name='unsub2'><kerio:text id='express-unsubscribe'/></a> - " : "");
$hqt .= "<a href='folder.php?goto=folderSharing&fld=" . urlencode($hgc['name']) . "'><kerio:text id='express-access-rights'/></a>";
}
else {
$d = $hqr;
$hqt = ($bvk[$hgc['name']] ? "<a href='folder.php?goto=folderUnsubscribe&rand=" . $_SESSION['rand'] . "&fld=" . urlencode($hgc['name']) . "' name='unsub2'><kerio:text id='express-unsubscribe'/></a> - " : "");
$hqt .= (strpos(strstr($hgc['name'], "/"), "/" . FLD_PUBLIC) !== false || 1?
"<a href='folder.php?goto=folderSharing&fld=" . urlencode($hgc['name']) . "'><kerio:text id='express-access-rights'/></a>" :
$hqr);

}
$ps = "row" . $hqs;
}
else {

$hqm = ($hgc['type'] == WME_NOT_SELECTABLE ? "folder" : "folder_gray"); $d = ($hgc['rights'] == "A" && ($hgc['name'] == "~" . $wd . "/" . FLD_PUBLIC || $hgc['name'] == "~" . $wd . "/" . FLD_ARCHIVE) ?
"<a href='folder.php?goto=folderCreate&fld=" . urlencode($hgc['name']) . "'><kerio:text id='express-new-subfolder'/></a>" :
$hqr);

if ($bvk[$hgc['name']]) {
$ps = "row" . $hqs;
$hqt = "<a href='folder.php?goto=folderUnsubscribe&rand=" . $_SESSION['rand'] . "&fld=" . urlencode($hgc['name']) .
($hgc['type'] == WME_NOT_SELECTABLE ? "&all=1' name='unsub'" : "' name='unsub2'") . "><kerio:text id='express-unsubscribe'/></a>";
}
else {
$hqt = (1 && ($hgc['name'] == "~" . $wd . "/" . FLD_PUBLIC || $hgc['name'] == "~" . $wd . "/" . FLD_ARCHIVE) ? "<a href='folder.php?goto=folderSharing&fld=" . urlencode($hgc['name']) . "'><kerio:text id='express-access-rights'/></a>" :
$hqr);
}
}

if ($bwj === WME_CURRENT_FOLDER) {
$him = "<b class='actFolder'>"; $hin = "</b>";
}
else {
$him = $hin = ""; }

$bi0 = ($_SESSION['pda'] == 1 || $hgc['shortLast'] == $hgc['nameLast'] ? "" : " title='" . $hgc['nameLast'] . "'");

switch ($hgc['type']) {
case KMS_FMAIL:
$hqu = "<a" . $bi0 . " href='browse.php?fld=" . urlencode($hgc['name']) . "' class='folder'" . ($ps ? " id='" . $ps . "'" : "") . ">"; $hqv = "</a>";
break;

case KMS_FCONTACT:
$hqu = "<a" . $bi0 . " href='contact.php?fld=" . urlencode($hgc['name']) . "' class='folder'" . ($ps ? " id='" . $ps . "'" : "") . ">"; $hqv = "</a>";
break;

default:
if ($ps == "") {
if ($bi0 == "") {
$hqu = "";
$hqv = "";
}
else {
$hqu = "<span" . $bi0 . ">";
$hqv = "</span>";
}
}
else {
$hqu = "<span" . $bi0 . " id='" . $ps . "'>"; $hqv = "</span>";
}
break;
}

if ($_SESSION['pda'] == 0) {
$dev .=
"<tr>" .
"<td nowrap>" .
"<img src='/default/gfx/trpix.gif' width='" . ($hgc['subList'] * 16 + 16) . "' height='16'>" .
"<img src='../default/gfx/" . $hqm . ($hgc['rights'] == "S" ? "s" : "") . ".gif' width='16' height='16' alt=''> " . $him .
$hqu . $hgc['shortLast'] . $hqv . $hin .
"</td>".
"<td align='right'>" . (substr($hgc['nameLast'], 0, 1) == "~" || $hgc['type'] == WME_NOT_SELECTABLE || $hgc['type'] == WME_NOT_ACCESSIBLE ? "&nbsp;" : $hgc['total']) . "</td>" .
"<td nowrap>" . $d . "</td>" .
"<td nowrap>" . $hqt . "</td>" .
"</tr>";
}
else {
$dev .=
"<tr>" .
"<td>" . "<img src='../default/gfx/" . $hqm . ($hgc['rights'] == "S" ? "s" : "") . ".gif' width='16' height='16' alt=''>" . "</td>" .
"<td>" . $him . $hqu . $hgc['nameLocal'] . $hqv . $hin . "<br>" . $d . ($d != $hqr && $hqt != $hqr ? " - " : "") . $hqt .
"</td>" .
"</tr>";
}
$hqs++;
}
print $dev; ?>

	</table><?php
}




function hgy($ak, $hip, $hqw) {

if ($hqw) {
$dev = "<kerio:text id='fld-new'/>";
$abm = $ak->getMyUserInfo();
$hpq = "~" . $abm->getUserName();
}
else {
$dev = "<kerio:text id='express-create-folder'/> \"" . $hip['nameLast'] . "\"";
$hpq = aa0($hip['name']);
}
?>
<br><h4 class='h4_small'><?php print $dev ?></h4><br>
<input type='hidden' name='actionn' value='folderCreate'>
<input type='hidden' name='srcFld'  value='<?php print $hpq ?>'>
<table cellspacing='0' cellpadding='2' border='0'>
<?php if ($_SESSION['pda'] == 0): ?>
<tr>
<td nowrap><kerio:text id='fld-new-name'/>:</td><td><input type='text' name='newFld'></td>
<td nowrap><kerio:text id='fld-new-type'/>:</td>
<td colspan='99' width='100%'>
<select name='fldType'>
<option value='<?php print KMS_FMAIL ?>'><kerio:text id='fld-type-mail'/></option>
<option value='<?php print KMS_FCONTACT . "'" . ($hip['type'] == KMS_FCONTACT ? "selected" : "") ?>><kerio:text id='fld-type-contact'/></option>
			</select>
		</td>
	</tr>

	<?php else: ?>

	<tr>
		<td nowrap><kerio:text id='fld-new-name'/>:</td><td width='100%'><input type='text' name='newFld' xclass='full'></td>
	</tr>
	<tr>
		<td nowrap><kerio:text id='fld-new-type'/>:</td>
		<td width='100%'>
			<select name='fldType'>
				<option value='<?php print KMS_FMAIL ?>'><kerio:text id='fld-type-mail'/></option>
				<option value='<?php print KMS_FCONTACT . "'" . ($hip['type'] == KMS_FCONTACT ? "selected" : "") ?>><kerio:text id='fld-type-contact'/></option>
			</select>
		</td>
	</tr>

	<?php endif; ?>

	</table>
	<br>
	<input type='submit' value='<kerio:text id='common-ok'/>'>&nbsp;<input type='submit' name='cancel' value='<kerio:text id='wap-back'/>'><?php
}




function hgz($hip) {

?>
	<br><h4 class='h4_small'><kerio:text id='express-rename-folder'/> "<?php print $hip['nameLast']?>"</h4><br>

	<input type='hidden' name='actionn' value='folderRename'>
	<input type='hidden' name='srcFld'  value='<?php print aa0($hip['name'])?>'>

	<table cellspacing='0' cellpadding='2' border='0'>
	<tr>
		<td nowrap><kerio:text id='fld-new-name'/>:</td><td><input type='text' name='newFld'></td>
	</tr>
	</table>
	<br>
	<input type='submit' value='<kerio:text id='common-ok'/>'>&nbsp;<input type='submit' name='cancel' value='<kerio:text id='wap-back'/>'><?php
}




function hh0($ak, $hdt) {

$hqx = $hdt[WME_CURRENT_FOLDER]['name'];
$hqy = substr($hqx, 0, strrpos($hqx, "/"));
$dev = "";

foreach ($hdt as $bwj => $hgc) {
if ($bwj === WME_CURRENT_FOLDER) continue; if ($hgc['rights'] == "R" || $hgc['rights'] == "E") continue; if ($hgc['name'] == $hqy || strpos($hgc['name'] . "/", $hqx . "/") === 0) continue; 
$dev .= "<option value='" . aa0($hgc['name']) . "'>" . $hgc['nameLocal'] . "</option>";
}

if ($hdt[WME_CURRENT_FOLDER]['subList'] != 0) {

$hma = ($_SESSION['pda'] == 0 ? USERNAME_LENGTH : PDA_USERNAME_LENGTH);

$abm = $ak->getMyUserInfo();
$wd = $abm->getUserName();
$dev =
"<option value='~" . $wd . "'>" .
(mb_strlen($wd) > $hma + 3 ? mb_substr($wd, 0, $hma) . "..." : $wd) .
"</option>" . $dev;
}
?>
	<br><h4 class='h4_small'><kerio:text id='express-move-folder'/> "<?php print $hdt[WME_CURRENT_FOLDER]['nameLast']?>"</h4><br>

	<input type='hidden' name='actionn' value='folderMove'>
	<input type='hidden' name='srcFld'  value='<?php print aa0($hdt[WME_CURRENT_FOLDER]['name'])?>'>

	<table cellspacing='0' cellpadding='2' border='0'>
	<tr>
		<td nowrap><kerio:text id='express-target-folder'/>:</td><td><select name='newFld'><?php print $dev?></select></td>
	</tr>
	</table>
	<br>
	<input type='submit' value='<kerio:text id='common-ok'/>'>&nbsp;<input type='submit' name='cancel' value='<kerio:text id='wap-back'/>'><?php
}


$dlp = array(
LEVEL_ADMIN => "lrswicda",
LEVEL_EDITOR => "lrswid",
LEVEL_READER => "lr"
);

$dlo = array(
LEVEL_ADMIN => "<kerio:text id='fld-sharing-administrator'/>",
LEVEL_EDITOR => "<kerio:text id='fld-sharing-editor'/>",
LEVEL_READER => "<kerio:text id='fld-sharing-reader'/>"
);



function dlq($dhq) {
foreach ($GLOBALS['dlp'] as $dlr => $dlg) {
$dls = true;
for ($az = 0; $az < strlen($dlg); $az++) {
if (!strstr($dhq, $dlg[$az])) {
$dls = false;
}
}
if ($dls) return $dlr;
}
}



function hha($ak, $hip) {

$abi = $ak->getFolderStore();
$cdu = $abi->getFolderAcl($hip['name'], &$hdh);

$abm = $ak->getMyUserInfo();
$wd = strtolower($abm->getUserName()); 
$hqz = (strpos($abi->getFolderAclMyrights($hip['name']), "a") !== false);

$az = 0; $dgu = 0;
foreach ($hdh as $cea) { $hdh[$az]['rights'] = $GLOBALS['dlo'][dlq($cea['rights'])];

if (strtolower($cea['name']) == $wd && strpos($cea['rights'], "O") !== false) { $hdh[$az]['rights'] = ""; $dgu--;
}
elseif (strpos($cea['rights'], "a") !== false) { 
if ($hip['name'] == "~" . $wd . "/" . FLD_PUBLIC || $hip['name'] == "~" . $wd . "/" . FLD_ARCHIVE) {
$dgu--;
}
}
$az++;
}
$dgu += $az;
$az = 0;
foreach ($hdh as $hqi) {
if (substr($hqi['name'], 0, 1) == "[") {
$hdh[$az]['icon'] = "<img src='/default/gfx/usersg.gif' width='16' height='16' alt='G' title=''>";
$hdh[$az]['display'] = aa0(substr($hqi['name'], 1, strlen($hqi['name']) - 2));
}
elseif (substr($hqi['name'], 0, 9) == 'authuser@') {
$hdh[$az]['icon'] = "<img src='/default/gfx/user_black.gif' width='16' height='16' alt=''>";
$hdh[$az]['display'] = '<kerio:text id="fld-sharing-domain-from"/> '. aa0(substr($hqi['name'], 9));
}
elseif ($hqi['name'] == 'authuser') {
$hdh[$az]['icon'] = "<img src='/default/gfx/user_black.gif' width='16' height='16' alt=''>";
$hdh[$az]['display'] = '<kerio:text id="fld-sharing-all"/>';
}
elseif ($hqi['name'] == 'anyone') {
$hdh[$az]['icon'] = "<img src='/default/gfx/user_black.gif' width='16' height='16' alt=''>";
$hdh[$az]['display'] = '<kerio:text id="fld-sharing-anonymous"/>';
}
else {
$hdh[$az]['icon'] = "<img src='/default/gfx/userg.gif' width='16' height='16' alt=''>";
$hdh[$az]['display'] = aa0($hqi['name']);
}
$az++;
}
?>
<script type="text/javascript" src="funcFolder.js?v=<?php print SERVER_HASH?>"></script>
<br><h4 class='h4_small'><kerio:text id='express-sharing-table'/> "<?php print $hip['nameLast']?>"</h4><br>
<?php
if (!$hqz) {
foreach ($hdh as $hqi) {
if ($hqi['rights'] == "") continue; $dev .= "&nbsp;" . $hqi['icon'] . "&nbsp;" . $hqi['display'] . " (" . $hqi['rights'] . ")<br>";
}
print $dev . "<br><input type='submit' name='cancel' value='<kerio:text id='wap-back'/>'>";
return;
}
$hr0 = ($dgu > 0 ? "radio" : "hidden"); ?>
<input type='hidden' name='fld' value='<?php print aa0($hip['name'])?>'>
<table cellspacing='0' cellpadding='2' border='0'>
<?php if ($_SESSION['pda'] == 0) :?>
<tr>
<td width='21'><input type='<?php print $hr0 ?>' name='actionn' value='sharingAdd' id='add' checked></td>
<td nowrap><label for='add'><kerio:text id='express-sharing-add'/></label></td>
<td>
<select name='userGroup'>
<option value='U'><kerio:text id='fld-sharing-user'/></option>
<option value='G'><kerio:text id='fld-sharing-group'/></option>
<option value='D'><kerio:text id='fld-sharing-domain'/></option>
<option value='A'><kerio:text id='fld-sharing-all'/></option>
<option value='X'><kerio:text id='fld-sharing-anonymous'/></option>
</select>
<input type='text' name='user1' size='15'>
</td>
<td>
<kerio:text id='express-sharing-rights'/>
</td>
<td>
<select name='rights'>
<option value='A'><kerio:text id='fld-sharing-administrator'/></option>
<option value='E'><kerio:text id='fld-sharing-editor'/></option>
<option value='R' selected><kerio:text id='fld-sharing-reader'/></option>
</select>
</td>
</tr>
<? else: ?>
<tr>
<td width='21'><input type='<?php print $hr0 ?>' name='actionn' value='sharingAdd' id='add' checked></td>
<td nowrap><label for='add'><kerio:text id='express-sharing-add'/></label></td>
</tr>
<tr>
<td>&nbsp;</td>
<td>
<select name='userGroup'>
<option value='U'><kerio:text id='fld-sharing-user'/></option>
<option value='G'><kerio:text id='fld-sharing-group'/></option>
<option value='D'><kerio:text id='fld-sharing-domain'/></option>
<option value='A'><kerio:text id='fld-sharing-all'/></option>
<option value='X'><kerio:text id='fld-sharing-anonymous'/></option>
</select>
</td>
</tr>
<tr>
<td>&nbsp;</td>
<td>
<input type='text' name='user1' size='15'>
</td>
</tr>
<tr>
<td>&nbsp;</td>
<td>
<kerio:text id='express-sharing-rights'/>
</td>
</tr>
<tr>
<td>&nbsp;</td>
<td>
<select name='rights'>
<option value='A'><kerio:text id='fld-sharing-administrator'/></option>
<option value='E'><kerio:text id='fld-sharing-editor'/></option>
<option value='R' selected><kerio:text id='fld-sharing-reader'/></option>
</select>
</td>
</tr>
<? endif; ?>
<?php if ($dgu > 0): ?>
<tr>
<td><input type='radio' name='actionn' value='sharingRemove' id='remove'></td>
<td nowrap colspan='4'><label for='remove'><kerio:text id='express-sharing-remove'/></label></td>
</tr>
<?php
$dev = ""; $az = 1;
foreach ($hdh as $hqi) {
if ($hqi['rights'] == "") continue; $dev .=
'<tr><td>&nbsp;</td><td colspan="4"><input ' .
'type="checkbox" name="user2[]" value="' . aa0($hqi['name']) . '" id="x' . $az . '">' .
'<label for="x' . $az . '">&nbsp;' . $hqi['icon'] . '&nbsp;' . $hqi['display'] . ' (' . $hqi['rights'] . ')</label>' .
'</td></tr>';
$az++;
}
print $dev;
?>
<?php endif; ?>
</table>
<br>
<input type='submit' name='ok' value='<kerio:text id='common-ok'/>'>&nbsp;<input type='submit' name='cancel' value='<kerio:text id='wap-back'/>'><p>
<?php
}

function hhb() {
?>
<br><h4 class='h4_small'><kerio:text id='express-sharing-subscribe'/>:</h4><br>
<input type='hidden' name='actionn' value='folderSubscribe'>
<table cellspacing='0' cellpadding='2' border='0'>
<tr>
<td><input type='text' name='user' size='15'></td>
</tr>
</table>
<br>
<input type='submit' name='ok' value='<kerio:text id='common-ok'/>'>&nbsp;<input type='submit' name='cancel' value='<kerio:text id='wap-back'/>'><?php
}

function hhc($d, $hip) {
switch ($d) {
case "folderDelete":
$ei = "<kerio:text id='fld-really-delete'/>";
$dn = $hip['nameLast'];
break;
case "folderUnsubscribeAll":
$ei = "<kerio:text id='express-sharing-unsubscribe'/>";
$dn = substr($hip['nameLast'], 1); print "<input type='hidden' name='all' value='1'>"; $d = "folderUnsubscribe";
break;
case "folderUnsubscribe":
$ei = "<kerio:text id='fld-really-disconnect'/>";
$dn = $hip['nameLast'];
break;
}
print "<br><h4>" . $ei . " \"" . $dn . "\"?</h4><br>";
?>
<input type='hidden' name='actionn' value='<?php print $d?>'>
<input type='submit' value='<kerio:text id='common-yes'/>'>&nbsp;<input type='submit' name='cancel' value='<kerio:text id='common-no'/>'>
<?php
}
?>