<?php


require_once('CalendarDailyEvent.inc');
require_once('calendarDaily.inc');
require_once('calendarWeekly.inc');
require_once('calendarMonthly.inc');
require_once('calendarCommon.inc');
require_once('calendarView.inc');

function aeo($aek, $zd, $ael, $aem, $aen) {
global $zj;
$abo = abp($aek, KMS_FCALENDAR);
$aep = abr($abo, KMS_FCALENDAR, KMS_FAREADWRITE);
unset($abo);
$aep->gotoUid($zd);
if (!$aep->isValid()) {
aeq('E_MESSAGE_BADUID', $aek);
aer('changeCalendarDateCommon', 'E_MESSAGE_BADUID', "folder: " . $aek . "; uid: " . base_convert($zd, 10, 16));
}
$aes = $aep->getCalendarEvent();
if (!is_null($aes)) {
$abv = $aes->copy();
}
unset($aes);
$aet = $abv->toString();
$aeu = ($abv->isAllDay() == true);
if ($aeu && sizeof($aen) == 2) {
$aev = zt($abv->getStartDateTime());
$aew = round(($aen[1] - $aen[0]) / CALENDAR_ONE_DAY);
$ael = gmmktime(0, 0, 0, $aev['mon'], $aev['mday'] + $aew, $aev['year']);
$aex = zt($abv->getEndDateTime());
$aem = gmmktime(0, 0, 0, $aex['mon'], $aex['mday'] + $aew, $aex['year']);
}
$abv->setStartDateTime($zj->toGmt($ael));
$abv->setEndDateTime($zj->toGmt($aem));
$abv->setAllDay($aeu ? true : false);
$aey = $aep->saveCalendarEvent($abv);
unset($aep);
if (!$aey) {
aeq('E_MESSAGE_SAVE', $aek);
aer('changeCalendarDateCommon', 'E_MESSAGE_SAVE', "folder: " . $aek . "; uid: " . base_convert($zd, 10, 16));
}
$aez = $abv->toString();
$af0 = true;
$afa = false;
if (strcmp($aez, $aet) != 0) {
$afb = $GLOBALS['abm']->getAllowedEmailAddresses();
$afc=$abv->getAttendees ();
unset($abv);
if (sizeof($afc)) foreach ($afc as $afd) {
$afe = in_array($afd['address'], $afb);
if (!$afe && $afd['rsvp'] && (!$afd['mailSent'] || $af0)) {
$afa = true;
}
}
}
if ($afa) {
echo 'aff.afg(' . afh($aek) . ',' . afh($zd) . ','
. KMS_FCALENDAR . ',"sendEventUpdatePrompt");' . "\n";
}
else {
echo 'aff.afi.afj.afk();' . "\n"
. 'aff.afl();' . "\n";
}
}

function afm($aek, $zd) {
global $ak, $abm, $zj;
$abi = $ak->getFolderStore();
$abo = $abi->openCalendarFolder($aek);
if (is_null($abo)) {
aeq('E_FOLDER_OPEN', $aek);
aer('getCalendarStartEndTime', 'E_FOLDER_OPEN', "folder: $aek");
}
$abq = $abo->createCalendarMessageIterator(KMS_FAREADONLY);
$abq->gotoUid($zd);
if (!$abq->isValid()) {
aeq('E_MESSAGE_BADUID', $aek);
aer('getCalendarStartEndTime', 'E_MESSAGE_BADUID', "folder: " . $aek . "; uid: " . base_convert($zd, 10, 16));
}
$aes = $abq->getCalendarEvent();
if (!is_null($aes)) {
$abv = $aes->copy();
}
$aet = $abv->toString();
$afn = $zj->fromGmt($aes->getStartDateTime());
$zu = $aes->getDuration();
$afo = ($aes->getEndDateTime() != 0) ? $zj->fromGmt($aes->getEndDateTime())
: $zj->fromGmt($aes->getStartDateTime()) + $zu;
return array('startDateTime'=>$afn, 'endDateTime'=>$afo);
}

function afq($aek, $zd, $afp, $qn) {
$afr = afm($aek, $zd);
$afn = $afr['startDateTime'];
$afo = $afr['endDateTime'];
$afs = $qn - $afp;
$aft = $afo - $afn;
$afu = zt($afn);
$ael = gmmktime($afu['hours'], $afu['minutes'], $afs, $afu['mon'], $afu['mday'], $afu['year']);
$aem = $ael + $aft;
echo "aff.afv = " . $qn . ";\n";
aeo($aek, $zd, $ael, $aem, array($afp, $qn));
}

function afx($aek, $zd, $afw, $zv) {
$afr = afm($aek, $zd);
$afn = $afr['startDateTime'];
$afo = $afr['endDateTime'];
$afy = $afo - $afn;
$zv = zt($zv);
$afz = floor($afw);
$ag0 = ($afw - $afz) * 60;
$ael = gmmktime($afz, $ag0, 0, $zv['mon'], $zv['mday'], $zv['year']);
$aem = $ael + $afy;
aeo($aek, $zd, $ael, $aem, array());
}

function agb($aek,$zd,$aga,$afw,$zv){
$afr = afm($aek,$zd);
$afn = $afr["startDateTime"];
$afo = $afr["endDateTime"];

$afy = $afo - $afn;

$zv = zt($zv);
$afz = floor($aga);
$ag0 = ($aga - $afz) * 60;

$ael = gmmktime($afz, $ag0, 0, $zv["mon"], $zv["mday"], $zv["year"]);
$aem = $ael + ($afw*60*60);
aeo($aek, $zd, $ael, $aem, array());


}


function agg($aek, $agd = "day", $zc = false, $zg, $age) {
global $agh, $zj, $agi, $abm;

if ($aek == "") $aek = $agh . "/" . FLD_CALENDAR;

echo "aff.agj();\n";

if ( ($zc == false) || ($zc <= 0) || (!is_numeric($zc)) )
$agk = time();
else
$agk = $zc;

$agl = CALENDAR_ONE_DAY * 32; $agm = CALENDAR_ONE_DAY * 24836; if ($agk < $agl) $agk = $agl;
if ($agk > $agm) $agk = $agm;

switch ($agd) {
case "day":
$agn = ago($agk, $aek, true);
$agp = 'aff.document.getElementById("buttonEventDay")';
break;
case "week":
$agn = agq($agk, $aek, true);
$agp = 'aff.document.getElementById("buttonEventWeek")';
break;
case "month":
$agn = agr($agk, $aek, true, $zg);
$agp = 'aff.document.getElementById("buttonEventMonth")';
break;
default:
$agn = "<h1>Wrong view!</h1>";
$agp = 'aff.document.getElementById("buttonEventDay")';
break;
}

echo "var gz = $agp;\n";
echo "aff.ags(gz);\n";

if ($age > 0 && 'month' == $agd) {
$agt = ($age > $zc);
define('HALF_DAY_IN_MONTH', 15);
$agu = ($agt) ? HALF_DAY_IN_MONTH : (-1 * HALF_DAY_IN_MONTH);
$agv = ($agt) ? agw($zc) + $agu * CALENDAR_ONE_DAY
: agx($zc) + $agu * CALENDAR_ONE_DAY;
$agy = agz(ah0(agx($agv)),
aha(agw($agv)));
foreach($agy as $ahb) {
if ($ahb['fromGmt'] <= $age && $ahb['toGmt'] > $age) {
$ahc = $ahb['day'];
break;
}
}
$ahd = floor($ahc / 7); $ahe = $ahc % 7; $ahf = agz(ah0(agx($zc)),
aha(agw($zc)));
$ahc = $ahd * 7 + $ahe; if ($ahd > 3 && empty($ahf[$ahc])) $ahc -= 7;
if ($ahd > 3 && empty($ahf[$ahc])) $ahc -= 7;
$agk = $ahf[$ahc]['from']; }
if ($agn != '') {
echo "aff.ahg=1;\n";
echo "aff.document.getElementById('mainNavig').style.height = 25 + 'px';\n"; echo "aff.ahh('" . ahi($agn) . "');\n";
$ahj = ($agd == 'month') ? 'md' : 'wd';
if ($agd == 'month' || $agd == 'week') echo "aff.ahk('" . $ahj . gmdate('Ymd', $agk) . "');\n";
echo "aff.afv = " . $agk . ";\n";
}
echo "aff.ahl();\n";
echo "if (aff.ahm) aff.ahl();\n"; if ($agi['fldDisplayCalendar'] != $agd) {
$ahn = $abm->getSettings();
$ahn['fldDisplayCalendar'] = $agd;
$abm->saveSettings($ahn);
}
}


function ahy($aek, $zd, $aec, $a0z, $aho, $ahp, $ahq, $aao, $ahr, $ahs,
$a0w, $afc, $aht, $ahu, $ahv, $ahw, $agd = 'list', $d,
$ahx) {
global $abm, $agi, $zj, $ak;
$ahz = '';

$abi = $ak->getFolderStore();
$abo = $abi->openCalendarFolder($aek); 
if (is_null($abo)) {
$aek = '~' . $abm->getUserName() . '/' . FLD_CALENDAR;
$abo = abp($aek, KMS_FCALENDAR);
if ($abo) {
$ahz .= 'alert("' . aaz('fld-unavailable-calendar') . '");' . "\n";
}
}

$ai0 = false;

if (empty($zd)) {
$abv = kerio('KMS::CalendarEventW');
$ai0 = true;
}
else {
$abq = abr($abo, KMS_FCALENDAR);
if ($abq->gotoUid($zd)) {
$aia = $abq->getCalendarEvent();
$abv = $aia->copy();
}
else {
$abv = kerio('KMS::CalendarEventW'); $ai0 = true;
}
}

$ahw = $ahw ? true : false;

$aet = $abv->toString();

$aib = $abv->getUID();
if (!$aib) $abv->setUID(aic($aec));

$aid = aie($abv, $afc, $d);

if ('sendEventUpdate' == $d && !empty($aid)) {
$ahz .= aif($abo, KMS_FCALENDAR, $zd, 'cancelEvent', '', $aid);
}

if (sizeof($aht)) {
$aig = kerio("KMS::RecurrenceRuleIterator");

if (is_null($abv->getTimeZone()))
$zv = $aig->start($aht,$ahp,true);
else
$zv = $aig->start_tz($aht,$ahp,$abv->getTimeZone(),true);

$ahq = $zv + ($ahq - $ahp);
$ahp = $zv;
}

if ($ai0) {
if (!empty($aih[0]['address'])) {
$aii = $aih[0];
}
else {
$aij = $abm->getAllowedEmailAddresses();
$aii = array('name' => $abm->getFullName(),
'address'=> ((empty($aij)) ? '' : $aij[0]));
}
$abv->setOrganizer($aii);
}

$abv->setSummary($aec);
$abv->setLocation($a0z);
$abv->setDescription($aho);

$ahv = explode(';', str_replace(',', ';', $ahv)); $aik = $ahv;
$ahv = array();
for ($az = 0; $az < sizeOf($aik); ++$az) {
$du = trim($aik[$az]);
if ($du && !in_array($du,$ahv)) array_push($ahv,$du);
}
$abv->setCategories($ahv);

if (sizeOf($ahv)) ail($ahv);

if ($ahw) {
$zv = zt($ahp);
$ahp = gmmktime(0, 0, 0, $zv["mon"], $zv["mday"], $zv["year"]);
$aim = zt($ahq);
$ahq = gmmktime(0, 0, 0, $aim["mon"], $aim["mday"]+1, $aim["year"]);
}

$abv->setTimeZone($zj); $abv->setStartDateTime($zj->toGmt($ahp)); $abv->setEndDateTime($zj->toGmt($ahq)); $abv->setAllDay($ahw ? true : false);
$aao = (0 == $aao) ? KMS_CPUBLIC : KMS_CPRIVATE;
$abv->setClass($aao);
$abv->setPriority($ahs);
$abv->setTransparency($a0w);
$ain = aio($abv->getPriority());
$abv->setLabel($ahu);
$abv->clearAlarms();

if ($ahr!='') {
$ac0=aca();
$ac0["relTrigger"]=$ahr;
$abv->addAlarm($ac0);
}

$aip = ($agi['firstWeekDay'] == 7 || $agi['firstWeekDay'] == 1) ? $agi['firstWeekDay'] : 1;

$abv->clearRecurrenceRules();
if (sizeof($aht)) {
$aht['weekStart'] = $aip;
$abv->addRecurrenceRule($aht);
}

$abw = abx($abv);
if ($abw > 0 && !$ai0) {
$aap = $abv->getAlarms();
if (sizeof($aap)) $aap = $aap[0];
if (sizeof($aap)) {
if ($aap["triggerType"] == KMS_ARELATEDSTART) {
$yx = $zj->fromGmt($abv->getStartDateTime());
$aap = $abv->getAlarms();
if (sizeof($aap)) $aap = $aap[0];
if (sizeof($aap)) {
$aby = $aap['relTrigger'];
$abw += $aby;
}
if ($ahw) {
$abw = $zj->toGmt($abw);
}
$abv->setNextAlarmDateTime($abw);
}
}
}

$aiq = false;
if ($ai0) {
$zd = $abo->insertCalendarEvent($abv);
if (0 < $zd) {
$aiq = true;
$abq = abr($abo, KMS_FCALENDAR);
}
}
else {
if (1 == $abq->saveCalendarEvent($abv) ) {
$aiq = true;
}
}

air($abq, $aek); if (!$aiq) {
aeq('E_MESSAGE_SAVE', $aek);
aer('saveCalendar', 'E_MESSAGE_SAVE', 'folder: ' . $aek . '; uid: ' . base_convert($zd, 10, 16));
}
if ($d == "sendEvent" || $d == "sendEventUpdate") {
$ahz .= aif($abo, KMS_FCALENDAR, $zd, $d);
}
unset($abq, $abv, $abo);
$ais = (empty($aht) || $ai0 || empty($ahx)) ? $ahp : $ahx;
$ahz .= 'aff = ait();' . "\n"; $ahz .= 'if (aff) aff.afv=' . $ais . ';' . "\n";

$aiu = 26;
$ahz .= 'if (aff) aff.aiv='
. round((gmdate('G', $ahp) + (gmdate('i', $ahp) / 60)) * $aiu * 2)
. ';' . "\n";

return array('result' => $aiq, 'javascript' => $ahz);
}


function aiz($aiw, $aix, $aiy) {
$dx = false;
if (sizeof($aix)) foreach($aix as $aj0) {
if ($aj0['type'] == $aiy) {
$aja = $aj0['numbers'];
if (in_array($aiw, $aja)) $dx = true;
}
if ($dx) break;
}
return $dx;
}


function ajc($aix, $aiy) {
$dx = array();
if (sizeof($aix)) foreach($aix as $aj0) {
if ($aj0['type'] == $aiy) {
$aja = $aj0['numbers'];
if (sizeOf($aja)) foreach($aja as $ajd) array_push($dx, $ajd);
}
if ($dx) break;
}
return $dx;
}


function ajb($aix, $aiy) {
$dx = ajc($aix, $aiy);
$dx = $dx[0];
return $dx;
}


function aje($ajf, $ajg = true) {
global $zj;
$dx = MAX_INT;
if (!is_null($ajf)) {
$dx = $ajf->getNextAlarmDateTime();
if ($dx != 0 && $ajg) {
return $dx;
}
$dx = MAX_INT;
$aap = $ajf->getAlarms();

if (sizeof($aap)) $aap = $aap[0];

if (sizeof($aap)) {
switch ($aap["triggerType"]) {
case KMS_ARELATEDSTART :
$yx = ($ajf->getStartDateTime());
$dx = ($yx + $aap["relTrigger"]);
break;
case KMS_ARELATEDEND :
$zu = $ajf->getDuration();
$yy = ($ajf->getEndDateTime() != 0)
? ($ajf->getEndDateTime())
: ($ajf->getStartDateTime()) + $zu;
$dx = ($yy + $aap["relTrigger"]);
break;
case KMS_AONDATETIME :
$dx = ($aap["dateTrigger"]);
break;
}
}
}
return $dx;
}


function ajh($aji, $ajj = false) {
$ajk = 0;
$aji = abs($aji);
$aji = round($aji / 60);
if ($aji > 60) {
$ajk = 1;
$aji = round($aji / 60);
if ($aji > 36) {
$ajk = 2;
$aji = round($aji / 24);
if ($aji > 14) {
$ajk = 3;
$aji = round($aji / 7);
}
}
}
$ajl = array('type'=>$ajk, 'value'=>$aji);
$ajm = '';
switch($ajl['type']) {
case 0: $ajm .= aaz('common-minutes'); break;
case 1: $ajm .= aaz('common-hours'); break;
case 2: $ajm .= aaz('common-days'); break;
case 3: $ajm .= aaz('common-weeks'); break;
}
if ($ajl['value'] == 0) return false;
if ($ajj) $ajm .= ': ' . $ajl['value'];
else $ajm = $ajl['value'] . ' ' . $ajm;
return ($ajm);
}


function ajn($aji) {
$aji = round(abs($aji) / 60 / 60 / 24);
$ajk = 'days';
if ($aji > 14) {
$ajk = 'weeks';
$aji = round($aji / 7);
}
$ajl = array('type'=>$ajk, 'value'=>$aji);
$ajm = '';
switch($ajl['type']) {
case 'days':
$ajm .= aaz('common-days');
break;
case 'weeks':
$ajm .= aaz('common-weeks');
break;
default:
break;
}
if ($ajl['value'] == 0) return false;
$ajm = $ajl['value'] . ' ' . $ajm;
return ($ajm);
}


function ajo($aek, $zd, &$aab) {
global $ak, $zj;
$abi = $ak->getFolderStore();
$abo = $abi->openCalendarFolder($aek);
$qp = $ak->getMyUserInfo();

if (is_null($abo)) {
aeq('E_FOLDER_OPEN', $aek);
aer('calendarFormatAsHTML', 'E_FOLDER_OPEN', "folder: $aek");
}

$ajp = false;
if ($zd != -1) {
$abq = $abo->createCalendarMessageIterator(KMS_FAREADONLY);
$abq->gotoUid($zd);
if (!$abq->isValid()) $ajp = true;
$abv = $abq->getCalendarEvent();
unset($abq, $abo);

if (!is_null($abv)) {
$wd = aa0($qp->getFullName());
$ajq = aa0($abv->getSummary());
$aab = $ajq;
$ajr = aa0($abv->getLocation());
$ajs = $abv->isAllDay();

if ($ajs) {
$ajt = '%kdate';
$aju = aan($ajt, $abv->getStartDateTime());
$ajv = aan($ajt, $abv->getEndDateTime() - CALENDAR_ONE_DAY);
if ($abv->getEndDateTime() == 0) { $ajv = aan($ajt, $abv->getStartDateTime() + $zu - CALENDAR_ONE_DAY);
}
}
else {
$ajt = '%kdate %ktime';
$aju = aan($ajt, $zj->fromGmt($abv->getStartDateTime()));
$ajv = aan($ajt, $zj->fromGmt($abv->getEndDateTime()));
if ($abv->getEndDateTime() == 0) { $ajv = aan($ajt, $zj->fromGmt($abv->getStartDateTime()) + $abv->getDuration());
}
}

$ain = aio($abv->getPriority());
$ajw = nl2br(aa0($abv->getDescription()));
$ajx = (KMS_CPUBLIC == $abv->getClass()) ? aaz('common-no') : aaz('common-yes');
$ajy = $abv->getRecurrenceRules();
if (sizeof($ajy)) $ajy = $ajy[0];
$ajz = sizeof($ajy) ? aaz('common-yes') : aaz('common-no');
switch ($abv->getTransparency()) {
case KMS_ETENTATIVE: $ak0 = aaz('event-transparency-tentative'); break;
case KMS_EOPAQUE: $ak0 = aaz('event-transparency-opaque'); break;
case KMS_EUNAVAILABLE: $ak0 = aaz('event-transparency-unaviable'); break;
default: $ak0 = aaz('event-transparency-transparent'); break;
}

$aka = akb($abv, KMS_FCALENDAR);

unset($abv);
}
else {
$ajp = true;
}
}
else {
$ajp = true;
}
if ($ajp) {
aeq('E_MESSAGE', $aek);
aer('calendarFormatAsHTML', 'E_MESSAGE', "folder: " . $aek . "; uid: " . base_convert($zd, 10, 16));
}

$dx = '<hr class="smallHR"><table border="0">'
. akc('<kerio:text id="eventtodo-summary"/>', $ajq)
. akc('<kerio:text id="eventtodo-location"/>', $ajr)
. akd()
. akc('<kerio:text id="eventtodo-begin"/>', $aju)
. akc('<kerio:text id="eventtodo-end"/>', $ajv);
if ($ajs) $dx .= akc('<kerio:text id="event-wholeday"/>', '<kerio:text id="common-yes"/>');
$dx .= akd()
. akc('<kerio:text id="eventtodo-priority"/>', $ain)
. akc('<kerio:text id="event-transparency"/>', $ak0)
. akd()
. akc('<kerio:text id="eventtodo-repeat"/>', $ajz)
. akc('<kerio:text id="eventtodo-private"/>', $ajx)
. $aka
. '</table><br>'
. $ajw;

return $dx;
}


function akb($abv, $ajk) {

$ake = akf($abv);
$afc = $abv->getAttendees();

$akg = '';
$akh = '';
$aki = '';
$akj = '';
foreach ($afc as $afd) {
$akk = kerio_parse_address_header($afd['name']);
if ($ake['address'] != $afd['address'] && $akk['address'] != $ake['address']) {
$akl = (($afd['address']) ? akm($afd) : $afd['name']) . ', ';
if ($ajk == KMS_FCALENDAR) {
switch ($afd['role']) {
case KMS_ARREQPARTICIPANT: $akg .= $akl; break;
case KMS_AROPTPARTICIPANT: $akh .= $akl; break;
case KMS_ARNONPARTICIPANT: $aki .= $akl; break;
default:
break;
}
}
elseif ($ajk == KMS_FTODO) {
$akj .= $akl;
}
}
}
$dx = akd();
$akn = ($ake['address']) ? akm($ake) : $ake['name'];
if ($ajk == KMS_FCALENDAR) {
if ($akg == '' && $akh == '' && $aki == '') return '';
if ($akn) $dx .= akc('<kerio:text id="event-meeting-organizer"/>', aa0($akn));
if ($akg) $dx .= akc('<kerio:text id="event-meeting-req"/>', aa0(substr($akg, 0, -2)));
if ($akh) $dx .= akc('<kerio:text id="event-meeting-opt"/>', aa0(substr($akh, 0, -2)));
if ($aki) $dx .= akc('<kerio:text id="event-meeting-non"/>', aa0(substr($aki, 0, -2)));
}
elseif ($ajk == KMS_FTODO) {
if ($akj == '') return '';
if ($akn) $dx .= akc('<kerio:text id="todo-organizer"/>', aa0($akn));
if ($akj) $dx .= akc('<kerio:text id="todo-coworker"/>', aa0(substr($akj, 0, -2)));
}

return $dx;
}


function akc($dn, $nr = '') {
if ($nr == '') return '<tr><td colspan="2"><span class="caption">' . $dn . '</span></td></tr>';
return '<tr>'
. '<td align="left" valign="top"><nobr><span class="caption">' . $dn . ':&nbsp;</span></nobr></td>'
. '<td align="left" valign="top">' . $nr . '</td>'
. '</tr>';
}


function akd() {
return '<tr><td colspan="2">&nbsp;</td></tr>';
}


function abx($yw) {
global $zj;
$ajy = $yw->getRecurrenceRules();
if (sizeof($ajy)) $ajy = $ajy[0];
if (!sizeof($ajy)) {
$dx = -1;
}
else {
$aig = kerio("KMS::RecurrenceRuleIterator");
if (is_null($yw->getTimeZone()))
$akp = $aig->start($ajy, $yw->getStartDateTime(), true);
else
$akp = $aig->start_tz($ajy, $yw->getStartDateTime(), $yw->getTimeZone(), true);
$aap = $yw->getAlarms();
if (sizeof($aap)) $aap = $aap[0];
$aby = (sizeof($aap)) ? $aap['relTrigger'] : 0;
while ($akp < time() - $aby && $akp) {
$akp = $aig->next();
}
if ($akp == 0) $dx = -1;
else $dx = $akp;
}
return $dx;
}


function agz($akq, $akr) {
global $zj;

$aks = 24*60*60;

$akt = array();
$aku = $zj->toGmt($akq);
$akv = $zj->toGmt($akr);

$az = 0;
while ($aku <= $akv) {
$akw = $zj->fromGmt($aku);
$akx = $zj->fromGmt($aku + $aks);
$aky = $aks + ($aks - ($akx - $akw));
if (($akx - $akw) != $aks) $akx = $akw + $aks;
array_push($akt, array('day' => $az,
'from' => $akw, 'to' => $akx,
'fromGmt' => $aku, 'toGmt' => $aku + $aks));
$aku = $aku + $aky;
$az++;
}
return $akt;
}


function akz($aed, $akq, $akr, $zh, $al0 = false) {
global $zj, $ak;

$aks = 24*60*60;

$abi = $ak->getFolderStore();
$aek = $abi->openCalendarFolder($aed);

if (is_null($aek)) {
aeq('E_FOLDER_OPEN', $aed);
aer('getCalendarFolderContent', 'E_FOLDER_OPEN', "folder: $aed");
}

$abq = $aek->createCalendarMessageIteratorEx(true);

$u = "(@Start <= $2) & (@TotalEnd >= $1)";
$ala = $aek->searchMessages(&$alb, &$alc, $u,
array(
ald($akq),
ald($akr + $aks, false))
);
if ($ala == 0) {
$abq->setSubset($alb); 
$ale = array();
for ($abq->gotoNumber(0), $az = 0; $abq->isValid(); $abq->gotoNext(), ++$az) {
array_push($ale, array('event'=>$abq->getCalendarEvent(), 'uid'=>$abq->getUid()));
}

$alf = array();
for ($az = 0; $az < sizeof($ale); $az++) {
$yw = $ale[$az]['event'];
if ($yw == null) {
$az++;
continue;
}
$ajy = $yw->getRecurrenceRules();
if (sizeof($ajy)) $ajy = $ajy[0];
$alg = $yw->getOccurrences($zj->toGmt($akq), $zj->toGmt($akr + $aks));
for ($alh = 0; $alh < sizeof($alg); $alh++) {
$ali = $zj->fromGmt($alg[$alh]['dtStart']); $alj = $zj->fromGmt($alg[$alh]['dtEnd']); if ($yw->isAllDay() == true) {
$ali = $alg[$alh]['dtStart'];
$alj = $alg[$alh]['dtEnd'];
}
$alk = $zj->fromGmt($yw->getStartDateTime());
$alm = $zj->fromGmt($yw->getEndDateTime());
$aln = ($yw->isAllDay() == true) ? true : false; $aln = ($alm - $alk > $aks) ? true : $aln;
$ajx = $yw->getClass();
$zi = (($ajx == KMS_CPRIVATE || $ajx == KMS_CCONFIDENTIAL) && alo($aek)) ? true : false;
if (gmdate('z', $ali) != gmdate('z', $alj)) {
$alp = $ali;
$alq = $alj;
if ($alm - $alk == $aks && gmdate('H', $ali) == 0 && gmdate('i', $ali))
$aln = true;
do {
$alq = gmmktime(0, 0, 0, gmdate('m', $alp),
gmdate('d', $alp) + 1, gmdate('Y', $alp));
if (gmdate('z', $alq) == gmdate('z', $alj) + 1) $alq = $alj;
array_push($alf, array('event' => $yw, 'from' => $alp, 'to' => $alq, 'uid' => $ale[$az]['uid'], 'allDay' => $aln, 'private' => $zi)); $alp = gmmktime(0, 0, 0, gmdate('m', $alp),
gmdate('d', $alp) + 1, gmdate('Y', $alp));
}
while ($alp < $alj);
}
else {
array_push($alf, array('event' => $yw, 'from' => $ali, 'to' => $alj, 'uid' => $ale[$az]['uid'], 'allDay' => $aln, 'private' => $zi)); }
}
} usort($alf, "alr");
$als = false; if ($als) {
echo '/*';
print_r($alf);
echo '*/';
}
}
return ($ala == 0) ? $alf : $ala;
}

function alv($alt, $afp, $qn, $alu, $yx, $afc) {
global $zj, $n0, $agi;
$alt = $zj->toGmt($alt);
$afp = alw(zx($alt, $afp, true));
$qn = alw(zx($alt, $qn, true));
$alx = $afp;
echo 'aly(';
$alz = agz($afp, $qn);
$am0 = array();
for ($az = 0; $az < sizeof($alz); $az++) {
$alz[$az]['txt'] = aan("%d", $alz[$az]['from']) . '. ' . ama($alz[$az]['from'])
. ', ' . amb($alz[$az]['from']);
$alz[$az]['hours'] = array();
$alx = $alz[$az]['fromGmt'];
while (gmdate('d', $zj->fromGmt($alz[$az]['fromGmt'])) == gmdate('d', $zj->fromGmt($alx))) {
$amc = ($agi['timeStyle'] == 'english')
? kerio_gmdate($n0, '%I:%M', $zj->fromGmt($alx))
: kerio_gmdate($n0, '%H:%M', $zj->fromGmt($alx));
array_push($alz[$az]['hours'], "'" . $amc . "'");
$alx += $alu;
}
$alz[$az]['sizeOfHours'] = sizeof($alz[$az]['hours']);
array_push($am0, '[' . $az . ', ' . $alz[$az]['sizeOfHours'] . ', \'' . $alz[$az]['txt'] . '\']');
}
echo '[' . implode(', ', $am0) . '], ';
$amd = array();
$amd['sizeOfHours'] = array();
$amd['hours'] = array();
$ame = array();
for ($az = 0; $az < sizeof($alz); $az++) {
if (!in_array($alz[$az]['sizeOfHours'], $amd['sizeOfHours'])) {
array_push($amd['sizeOfHours'], $alz[$az]['sizeOfHours']);
array_push($amd['hours'], $alz[$az]['hours']);
array_push($ame, $alz[$az]['sizeOfHours'] . ', [' . implode(', ', $alz[$az]['hours']) . '] ');
}
}
echo '[' . implode(', ', $ame) . ']);' . "\n";
$afc = explode(';', $afc);
for ($az = 0; $az < sizeof($afc); $az++) {
$amf = explode(' ', $afc[$az], 2);
$amg = ($az >= 30) ? 1 : 0;
amh($amf[0], $amf[1], $yx, 0, $amg);
}
}

function amh($ami, $amj, $yx, $amk = 0, $amg = 0) {
global $ak, $agi, $abm, $zj;
$aml = kerio_parse_address_header($amj);
$amm = $aml[0]['address'];
$amn = $amm;
if (strpos($amm, "@") === false) {
$abi = $ak->getFolderStore();
$abm = $ak->getMyUserInfo();
$amm .= strstr($abm->getUserName(), "@");
}
if (trim($amm) != "") {
$yy = zx($yx, 4); $yx = zx($yx, -2);

if (1 == $amg) {
echo 'amo(\'' . $ami . ' ' . (($yy - $yx) / (60 * 30)) . ',notavailable\');' . "\n";
return;
}
$abi = $ak->getFolderStore();
$amp = ($agi["freeBusyInterval"] > 0) ? $agi["freeBusyInterval"] : 30;
$amq = $abi->retrieveFreeBusyData($amm, $zj->toGmt($yx), $zj->toGmt($yy), $amp);
define('MAX_FREE_BUSY_LENGTH', 336); $amr = strlen($amq);
if ($amr > MAX_FREE_BUSY_LENGTH) {
$amr = MAX_FREE_BUSY_LENGTH;
}

$ams = '';
$ajd = 1;
$amt = true;
$amu = substr($amq, 0, 1);
for ($az = 1; $az < $amr; $az++) {
$amv = substr($amq, $az, 1);
if ($amv != 'X') $amt = false;
if ($amv == $amu) {
$ajd++;
}
else {
$ams .= $ajd . ',' . $amu . ',';
$ajd = 1;
}
$amu = $amv;
}
$ams .= $ajd . ',' . $amu;
echo 'amo(\'' . $ami . ' ' . $ams . '\');' . "\n";
if ('' != trim($amk) && $amn != $amm && !$amt) {
echo 'amw(0,' . $ami . ',\'' . aa0($amm) . '\');';
}
}
}

function acc($aed, $ajk, $amx = true) {
global $zj;
$amy = time();
$amz = array();
if ($ajk != KMS_FCALENDAR && $ajk != KMS_FTODO) return $amz;
$abo = abp($aed, $ajk);
$an0 = '(@Alarm < $1)';
$ana = array(ald($zj->fromGmt(time()) + CALENDAR_ONE_DAY));
$ala = $abo->searchMessages(&$anb, &$alc, $an0, $ana);
$abq = abr($abo, $ajk);
unset($abo);
$abq->setSubset($anb); for ($abq->gotoNumber(0); $abq->isValid(); $abq->gotoNext()) {
switch ($ajk) {
case KMS_FCALENDAR: $abt = $abq->getCalendarEvent(); break;
case KMS_FTODO: $abt = $abq->getCalendarTodo(); break;
default: $abt = null; break;
}
if (is_null($abt)) continue;
if ($amx == true && aje($abt) > $amy) continue;
if ($amx == false) {
array_push($amz, aje($abt));
unset($abt);
continue;
}
if ($ajk == KMS_FCALENDAR) {
$anc = $abt->getStartDateTime() - time();
$aea = $abt->getStartDateTime();
if (sizeOf($abt->getRecurrenceRules()) != 0) {
$ane = $abt->getLastAndNextOccurrence($zj->toGmt(anf(true)));
if ($zj->fromGmt(aje($abt)) < anf(true)) {
$anc = $ane[0] - time();
$aea = $ane[0];
$ang = (4 / 3);
if ((($ane[1] - $ane[0]) / $ang) < (-1 * $anc)) {
$anc = $ane[1] - time();
$aea = $ane[1];
}
}
else {
$anc = $ane[1] - time();
$aea = $ane[1];
}
if ($aea < CALENDAR_ONE_DAY) {
$anc = $ane[0] - time();
$aea = $ane[0];
}
if ($abt->isAllDay() == true) $aea = $aea + date('Z', $aea);
}
if ($abt->isAllDay() != true) $aea = $zj->fromGmt($aea);
$aea = ($aea > 0) ? amb($aea) . ', ' . aan("%kdate %ktime", $aea)
: aaz('common-unknown');
$aeb = ajh($anc);
if (ajh($anc)) {
if ($anc < 0) $aeb .= ' ' . aaz('alarm-expires');
}
else {
$aeb = aaz('alarm-now');
}
}
elseif ($ajk == KMS_FTODO) {
$anh = $abt->getDueDateTime();
$anc = $zj->toGmt($anh) - time();
if (sizeOf($abt->getRecurrenceRules()) != 0) {
$ane = $abt->getLastAndNextOccurrence($zj->toGmt(anf(true)));
if ($zj->fromGmt(aje($abt)) < anf(true)) {
$anc = $ane[0] - time();
$anh = $ane[0];
$ang = (4 / 3);
if ((($ane[1] - $ane[0]) / $ang) < (-1 * $anc)) {
$anc = $ane[1] - time();
$anh = $ane[1];
}
}
else {
$anc = $ane[1] - time();
$anh = $ane[1];
}
if ($aea < CALENDAR_ONE_DAY) {
$anc = $ane[0] - time();
$aea = $ane[0];
}
}
$anc += CALENDAR_ONE_DAY;
$aea = ($abt->getDueDateTime() > 0) ? amb($anh) . ', '
. aan("%kdate", $anh) : aaz('common-unknown');
if ($anc > 0) {
$aeb = ($anc < CALENDAR_ONE_DAY) ? aaz('common-today') : ajn($anc);
}
else {
$aeb = (abs($anc) < CALENDAR_ONE_DAY) ? aaz('mail-search-date-yesterday') . ' - ' : ajn($anc);
}
if (ajh($anc)) {
if ($anc < 0) $aeb .= ' ' . aaz('alarm-expires');
}
else
$aeb = aaz('alarm-now');
if (!($abt->getDueDateTime() > 0)) $aeb = aaz('common-unknown');
}
array_push($amz, array('uid' => $abq->getUID(),
'folderName' => $aed,
'summary' => $abt->getSummary(),
'location' => $abt->getLocation(),
'scheduleDateTime' => $aea,
'alarmText' => $aeb,
));
unset($abt);
}
unset($abq);
return $amz;
}
function ani($n0){
$anj = '';
$zv = gmmktime(1,1,1,2,1,2003);
$ank = kerio_gmdate($n0,"%x",$zv);
if (!ereg("([0-9]+)([^0-9]+)([0-9]+)([^0-9]+)([0-9]+)",$ank,$anl)) return false;
$anj="";
if (1 == $anl[1]) $anj .= str_repeat("d",strlen($anl[1]));
elseif (2 == $anl[1]) $anj .= str_repeat("m",strlen($anl[1]));
else $anj .= str_repeat("y",strlen($anl[1]));
$anj .= $anl[2];
if (1 == $anl[3]) $anj .= str_repeat("d",strlen($anl[3]));
elseif (2 == $anl[3]) $anj .= str_repeat("m",strlen($anl[3]));
else $anj .= str_repeat("y",strlen($anl[3]));
$anj .= $anl[4];
if (1 == $anl[5]) $anj .= str_repeat("d",strlen($anl[5]));
elseif (2 == $anl[5]) $anj .= str_repeat("m",strlen($anl[5]));
else $anj .= str_repeat("y",strlen($anl[5]));
return array("format"=>$anj,"separator1"=>$anl[2],"separator2"=>$anl[4]);
}

function amb($agk) {
$agk = ano($agk);
switch(gmdate('w', $agk)) {
case 0: return aaz('date-sunday'); break;
case 1: return aaz('date-monday'); break;
case 2: return aaz('date-tuesday'); break;
case 3: return aaz('date-wednesday'); break;
case 4: return aaz('date-thursday'); break;
case 5: return aaz('date-friday'); break;
case 6: return aaz('date-saturday'); break;
case 7: return aaz('date-sunday'); break;
default: return ''; break;
}
}

function ama($agk) {
$agk = ano($agk);
switch(gmdate('n', $agk)) {
case 1: return aaz('date-january'); break;
case 2: return aaz('date-february'); break;
case 3: return aaz('date-march'); break;
case 4: return aaz('date-april'); break;
case 5: return aaz('date-may'); break;
case 6: return aaz('date-june'); break;
case 7: return aaz('date-july'); break;
case 8: return aaz('date-august'); break;
case 9: return aaz('date-september'); break;
case 10: return aaz('date-october'); break;
case 11: return aaz('date-november'); break;
case 12: return aaz('date-december'); break;
default: return ''; break;
}
}

function anp($zv){
global $n0;
return kerio_gmdate($n0, "%Y-%m-%d %H:%M:%S", $zv);
}


function anq(){
global $agi;
$anr = aaz("categories-default");
if (trim($agi["categories"]) != "") $anr .=";".trim($agi["categories"]);
return explode(';', str_replace(',', ';', $anr)); }


function ail($ant){
global $agi;
$anu = array();
$anv = anw(";", str_replace(',', ';', $agi["categories"])); $anr = anw(";", str_replace(',', ';', aaz("categories-default"))); 
if (sizeOf($anr) && sizeOf($ant)) foreach($ant as $abv){
if (!in_array($abv,$anr) && !in_array($abv,$anu)){
array_push($anu,$abv);
}
}

if (sizeOf($anu) && sizeOf($anv)) forEach($anu as $abv){
if (!in_array($abv,$anv)){
array_push($anv,$abv);
}
}

aeg("categories", implode(";",$anv), '', true, "");
}


function any($anx) {
global $zj, $n0;
$anz = aaz('common-unknown');
$ao0 = $zj->fromGmt($anx->getStartDateTime());
$aoa = $zj->fromGmt($anx->getEndDateTime());
$zu = $anx->getDuration();
if ($anx->getEndDateTime() == 0) $aoa = $ao0 + $zu;
if ($zu == 0) $zu = $aoa - $ao0;

if ($anx->isAllDay()) {
if ($anx->getStartDateTime() > 0) {
$alt = aan("%a, ", $anx->getStartDateTime()) . aan("%kerio ", $anx->getStartDateTime());
} else {
$alt = $anz;
}
if ($anx->getEndDateTime() != 0) {
$aob = aan('%a, ', $anx->getEndDateTime() - CALENDAR_ONE_DAY)
. aan('%kerio ', $anx->getEndDateTime() - CALENDAR_ONE_DAY);
} else {
$aob = $anz;
}
}
else {
$alt = ($ao0 > 0) ? aan("%a, ", $ao0) . aan("%kerio ", $ao0) . aoc($ao0) : $anz;
$aob = ($aoa > 0) ? aan("%a, ", $aoa) . aan("%kerio ", $aoa) . aoc($aoa) : $anz;
}

$afc = $anx->getAttendees();
$aod = array();
foreach ($afc as $aoe) {
$aod[] = aof($aoe);
}
$aog = implode(", ", $aod);
$aoh = (sizeOf($anx->getRecurrenceRules()) != 0) ? "yes" : "no";

$aoi = aau($anx) ? 'yes' : 'no';
$aav = aaw($anx) ? 'sendDecline="1"' : '';
$ahs = ($anx->getPriority() == 0) ? 5 : $anx->getPriority();

$a0y = 200;
$dx = afh($aoh) . ","
. afh($ahs) . ","
. afh(aa0(aaa($anx->getSummary(), $a0y))) . ","
. afh(aa0(aaa($anx->getLocation(), $a0y))) . ","
. afh($alt) . ","
. afh($aob) . ","
. afh(ajh($zu)) . ","
. afh(aa0(aaa($aog, $a0y))) . ","
. afh($aoi) . ","
. afh($aav);
return $dx;
}


function aca($aoj = false) {
global $zj;
$aoj = ($aoj) ? anf(true) : $zj->fromGmt(0);
return array ('action' => 0, 'description' => '', 'triggerType' => 0, 'relTrigger' => -900, 'dateTrigger' => $aoj);
}
function aok($ahs){
$dx=0;
if ($ahs==0) $ahs=5;
if ($ahs<5) $dx=1;
elseif ($ahs>5) $dx=-1;
return $dx;
}


function akf($yw) {

if (isset($yw)) {
$ake = $yw->getOrganizer();
}
if (empty($ake['address']) || !isset($yw)) {
$qp = $GLOBALS['ak']->getMyUserInfo();
$aij = $qp->getAllowedEmailAddresses();
$amm = (sizeof($aij)) ? $aij[0] : '';
$ake = array('name' => $qp->getFullName(),
'address' => ((empty($aij)) ? '' : $aij[0]));
}
return $ake;
}

function aol($afd){
global $ak;
$anj=($afd["role"]==KMS_ARCHAIR);return $anj;
}

function a0l($yw,$ans){
$dx=false;
if (sizeOf($ans)) foreach($ans as $aon){
if ($yw->zd==$aon->zd){
$dx=true;
break;
}
}
return $dx;
}

function aak($yw,$ans){
$dx=-1;
$az=0;
if (sizeOf($ans)) foreach($ans as $aon){
if ($yw->zd==$aon->zd){
$dx=$az;
break;
}
++$az;
}
return $dx;
}


function aau($yw) {
if (aoo($yw)) {
$aop = $yw->getAttendees();
foreach ($aop as $afd) {
if ($afd['mailSent'] == true)
return true;
}
}
return false;
}


function aoo($yw) {
global $ak;
$qp = $ak->getMyUserInfo();
$aoq = $qp->getAllowedEmailAddresses();
$aor = array_pop($yw->getOrganizer());
$aos = false;
foreach ($aoq as $aot) {
if ($aot == $aor) {
$aos = true;
}
}
return $aos;
}


function aaw($yw) {
return (!aoo($yw));
}


function aou($ala) {
echo "aff.agj();\n";
echo "aff.ahh('');\n";
echo "aff.aov('" . aow($ala) . "', 'mainContent');\n";
echo "aff.document.getElementById('frameMainHeader').style.display = '';\n";
}


?>
