<?php


function bqb($bqa) {
switch ($bqa) {
case KMS_TCOMPLETED: return aaz('todo-status-completed', false); break;
case KMS_TNEEDSACTION: return aaz('todo-status-needscooperation', false); break;
case KMS_TINPROCESS: return aaz('todo-status-inprogress', false); break;
case KMS_TCANCELLED: return aaz('todo-status-canceled', false); break;
default: return aaz('todo-status-notstarted', false); break;
}
}

function aio($ahs){
$ahs = bii($ahs,true);
switch ($ahs) {
case 1: return PRIORITY_HIGH; break;
case 5: return PRIORITY_NORMAL; break;
case 9: return PRIORITY_LOW; break;
}
}

function bii($ahs,$bqc=false){
if ($ahs==0) $ahs=5;
if ($bqc){
if ($ahs<5) $ahs=1;
elseif ($ahs>5) $ahs=9;
}
return $ahs;
}

function bqd($yw, $bqe = true) {
global $zj;
$bqf = $zj->fromGmt($yw->getStartDateTime());
$zu = $yw->getDuration();
$bqg = ($yw->getEndDateTime() != 0) ? $zj->fromGmt($yw->getEndDateTime())
: $zj->fromGmt($yw->getStartDateTime()) + $zu;
if ($yw->getStartDateTime() <= 0 && $yw->getEndDateTime() <= 0) {
$ni = aaz('common-unknown');
return $ni;
}
if ($yw->isAllDay()) {
$afw = round(($bqg - $bqf) / 3600, 2);
if ($afw <= 24) {
return aan('%a %kdate', $bqf) . ' (1 ' . aaz('event-alarm-day1') . ')';
} else {
return aan('%a %kdate', $bqf) . ' - ' . aan('%a %kdate', $bqg - CALENDAR_ONE_DAY) .
' (' . round($afw / 24) . ' ' . aaz('event-alarm-days1') . ')';
}
}
if (gmdate('Y-m-d', $bqf) != gmdate('Y-m-d', $bqg)) {
$ni = aan('%a %kdate %ktime', $bqf) . ' - ' . aan('%a %kdate %ktime', $bqg);
}
else {
$ni = aan('%a %kdate %ktime', $bqf) . ' - ' . aan('%ktime', $bqg);
}
if ($bqe) {
$afw = round(($bqg - $bqf) / 3600, 2);
switch ($afw) {
case 1: $ajm = aaz('event-alarm-hour'); break;
case 2:
case 3:
case 4: $ajm = aaz('event-alarm-hours1'); break;
default: $ajm = aaz('event-alarm-hours2'); break;
}
$ni .= ' (' . $afw . ' ' . $ajm . ')';
}
return $ni;
}

function bqh($anx, $bqi = 'text')
{
global $zj;
$bqj = $anx->getAttendees();
foreach ($bqj as $aoe) {
$bqk[$aoe['role']][] = $aoe['address'];
if ($anx->getMethod() == KMS_MREPLY) { $bql = $aoe['status'];
$bqm = $aoe['address'];
}
}
$bqn = $anx->getStartDateTime();
$aji = $zj->fromGmt($bqn);
$bqo = $aji - $bqn;
$bqp = array(
array(aaz('eventtodo-summary'), $anx->getSummary()),
array(aaz('eventtodo-location'), $anx->getLocation()),
array(aaz('mail-event-when'), bqd($anx)." (".bqq($bqo).")"),
array(aaz('eventtodo-attendees-requested'), @implode(", ", $bqk[KMS_ARREQPARTICIPANT])),
array(aaz('eventtodo-attendees-optional'), @implode(", ", $bqk[KMS_AROPTPARTICIPANT]))
);
$aho = $anx->getDescription();
switch ($bql) {
case KMS_ASACCEPTED:
$bqr = $bqm.' '.aaz("mail-event-user-accepted");
break;
case KMS_ASTENTATIVE:
$bqr = $bqm.' '.aaz("mail-event-user-tentative");
break;
case KMS_ASDECLINED:
$bqr = $bqm.' '.aaz("mail-event-user-declined");
break;
}
switch ($bqi) {
case "html":
if ($bqr) $agn = "<p style='font: 12px Verdana, Arial, sans-serif'><b>".$bqr."</b></p>\n";
$agn.= "<table style='font: 12px Verdana, Arial, sans-serif'>\n";
foreach($bqp as $bqs) {
if (strlen($bqs[1]) > 0) {
$agn.= "<tr><td><b>".bqt($bqs[0]).":</b></td><td>".$bqs[1]."</td></tr>\n";
}
}
$agn.= "</table>\n\n<p style='font: 12px Verdana, Arial, sans-serif'>".nl2br($aho)."</p>\n";
break;
case "text":
default:
if ($bqr) $agn = $bqr."\n\n";
foreach($bqp as $bqs) {
if (strlen($bqs[1]) > 0) {
$agn.= bqt($bqs[0]).": ".$bqs[1]."\n";
}
}
$agn.= "\n".$aho."\n";
}
return $agn;
}

function bil($bqu,$yw){
global $ak;
$dx=array();
if (sizeof($bqu)) foreach ($bqu as $afd){
if ($afd["role"]==KMS_ARCHAIR){
$dx=$afd;
break;
}
}

return $dx;
}
?>