<?php

require_once('lib/mail.inc');
require_once('lib/mailView.inc');
require_once('lib/mailSend.inc');
define('LINE_MAX', 76);
define('MAIN_CONTENT_SELECTOR', 'messageContent');
define('SPELLCHECKER_MAX_WORD_LENGTH', 35);
define('SPELLCHECKER_MAX_SUGGESTIONS_NUMBER', 30);
define('SPELLCHECKER_JS_LONGWORD', '--LONGWORD--');
define('SPELLCHECKER_JS_NOMORESUGG', '--NOMORE--');

$e0h = array(
KMS_FMAIL => 'eml',
KMS_FCONTACT => 'vcf',
KMS_FCALENDAR => 'ics',
KMS_FTODO => 'ics',
KMS_FNOTE => 'txt'
);

function dri($e0i, $ajm, $cxk) {
global $ak;
$e0j = $ak->createSpellChecker($e0i);
$ajm = preg_replace("/<\?xml[^>]*>/si", '', $ajm); if ('plain' == $cxk) {
$ajm = aa0($ajm); }
$e0k = true; $cdv = kerio_words(substr($e0i, 0, 2), $ajm, $e0k); $e0l = array();
$e0m = array();
$e0n = 0;

foreach ($cdv as $e0o => $cdq) {

if (!$e0j->check($cdq["word"])) {
$e0p = $cdq['word'];
$cdq['position'] = $e0o; 
if (mb_strlen($e0p) > SPELLCHECKER_MAX_WORD_LENGTH) {
$cdq['suggestions'] = array(SPELLCHECKER_JS_LONGWORD);
}
else if (isset($e0m[$e0p])) { $cdq['suggestions'] = $e0m[$e0p];
}
else if ($e0n >= SPELLCHECKER_MAX_SUGGESTIONS_NUMBER) {
$cdq['suggestions'] = array(SPELLCHECKER_JS_NOMORESUGG);
}
else {
$e0n++;
$cdq['suggestions'] = $e0j->suggest($e0p);
$e0m[$e0p] = $cdq['suggestions'];
}
array_push($e0l, $cdq);
}
}

$dnh = count($e0l);
for ($az = count($e0l)-1; $az >= 0; $az--) { $e0q = $e0l[$az];
$ajm = mb_substr($ajm, 0, $e0q['position'])
. '<span class="hit" id="keriow' . $dnh-- . '" s="' . aa0(implode('|', $e0q['suggestions'])) . '">'
. $e0q['word'] . '</span>' . $e0q['tags']
. mb_substr($ajm, $e0q['position']+$e0q['length']);
}



if (count($e0l) == 0) {
echo "alert('" . aaz('mail-spellchecker-nomistake') . "');\n";
echo "top.close()\n;";
} else {
echo "aff.e0v = " . count($e0l) . ";\n";
echo "aff.brt = \"" . ahi($ajm, 0, false) . "\";\n";
echo "aff.e0w();\n";
}
}


function dhx($abq, $cnb) {
global $n0,$abm;


$ajk = e0y($abq);
$e0z = bwc(bvc($abq->getDeliveryTime()));
$ea0 = eaa($abq);
$eab = $cnb->getSubject();
$afp = aof($cnb->getFromAddress());


switch ($ajk) {
case KMS_FMAIL:
$qn = trim($cnb->getNewsgroups());
if (!$qn) {
$qn = aof($cnb->getToAddresses());
}
$eac = aof($cnb->getCcAddresses());

$ead = $cnb->getDate();
$ead = ($ead > 0 ? bwc(bvc($ead)) : "");
break;
case KMS_FCALENDAR:
$bib = $abq->getBody();
$atf = $bib->getContents();
$yw = $atf->toCalendarEvent();
if (!is_null($yw)){
if (!$eab) $eab = $yw->getSummary();
if (!$afp){
$eae = bil($yw->getAttendees(),$yw);
$afp = $eae["name"];
}
}
break;
case KMS_FTODO:
$bib = $abq->getBody();
$atf = $bib->getContents();
$yw = $atf->toCalendarTodo();
if (!is_null($yw)){
if (!$eab) $eab = $yw->getSummary();
if (!$afp){
$eae = bil($yw->getAttendees(),$yw);
$afp = $eae["name"];
}
}
break;
case KMS_FCONTACT:
$bib = $abq->getBody();
$atf = $bib->getContents();
$bsk = $atf->toContact();
if (!is_null($bsk)){
if (!$eab) $eab = $bsk->getCommonName();
if (!$afp) $afp = $abm->getUserName();
$eaf = $bsk->isDList() ? CONTACT_TYPE_DLIST : CONTACT_TYPE_CONTACT;
}
break;
case KMS_FNOTE:
$bib = $abq->getBody();
$atf = $bib->getContents();
$eag = $atf->toStickyNote();
if (!is_null($eag)) {
$eaf = $eag->getColor();
}
break;
}


if ($ajk == KMS_FMAIL) {
$aao = $abq->getMapiClass();
if (strstr($aao, "IPM.Schedule.Meeting"))
$ajk = KMS_FCALENDAR;
if (strstr($aao, "IPM.TaskRequest"))
$ajk = KMS_FTODO;
}


$dx = '';
$dx .= afh($cnb->getPriority()) . ",";
$dx .= afh($cnb->hasAttachments()) . ",";
$dx .= afh($ea0) . ",";
$dx .= afh(aa0($afp)) . ",";
$dx .= afh(aa0(aaa($eab, 1000))) . ","; $dx .= afh($e0z) . ",";
$dx .= afh($ead) . ",";
$dx .= afh(bwb($abq->getSize())) . ",";
$dx .= afh(aa0(aaa($qn, 1000))) . ",";
$dx .= afh(aa0(aaa($eac, 1000))) . ",";
$dx .= afh($ajk);
if (isset($eaf)) { $dx .= "," . afh($eaf);
}
return $dx;
}


function dpu($aek, $zd, $eah, $eai, $cfz, $cg0)
{
global $agi, $eaj;


$abo = abp($aek, KMS_FMAIL);
$abq = abr($abo, KMS_FMAIL);

$abq->gotoUid($zd);

if ($abq->isValid() == false) {
aeq('E_MESSAGE_BADUID',$aek);
aer('getMessageContent','E_MESSAGE_BADUID', "folder: " . $aek . "; uid: " . base_convert($zd, 10, 16));
}


if ($_POST['desktop'] == 'mailView.php') {

$anb = dgq($abo, KMS_FMAIL, $cfz, $cg0);
$abq->setSubset($anb);
$abq->gotoUid($zd);

$eak = ($abq->gotoPrev() ? $abq->getUid() : -1);
$abq->gotoUid($zd);

$abw = ($abq->gotoNext() ? $abq->getUid() : -1);
$abq->gotoUid($zd);

echo "aff.c0x = " . $zd . ";\n";
echo "aff.eal = " . $eak . ";\n";
echo "aff.eam = " . $abw . ";\n";
}

unset($abo);


$bib = $abq->getBody();

if ($bib->findContentType("application", "ms-tnef")) {
$abq->convertFromTnef();
$bib = $abq->getBody(); }

if ($bib->hasUuencodedPart()) {
$abq->convertUuencodedAttachment();
$bib = $abq->getBody(); }

$atf = $bib->getContents();
$cnb = $abq->getEnvelope();


if ($eai != "") {
$atf = ean($atf, $eai);
$atf = $atf->toMessageBody();
$cnb = $atf;
$atf = $atf->getContents(); $eai .= ".0"; } else $eai = 0;


$qn = trim($cnb->getNewsgroups());
if (!$qn) {
$qn = aof($cnb->getToAddresses(), 'full_preview');
}

$eac = aof($cnb->getCcAddresses(), 'full_preview');
$eao = aof($cnb->getBccAddresses(), 'full_preview');
$eap = $cnb->getSubject();
$eaq = 'false';

if (!$eap) {
$ajk = e0y($abq);
switch ($ajk) {
case KMS_FCALENDAR:
$yw = $atf->toCalendarEvent();
if (!is_null($yw)) $eap = $yw->getSummary();
break;
case KMS_FTODO:
$yw = $atf->toCalendarTodo();
if (!is_null($yw)) $eap = $yw->getSummary();
$eaq = 'true';
break;
case KMS_FCONTACT:
$yw = $atf->toContact();
if (!is_null($yw)) $eap = $yw->getCommonName();
break;
}
} else {
$aao = $abq->getMapiClass();
if (strstr($aao, 'IPM.TaskRequest')) {
$eaq = 'true';
}
}

$zv = $cnb->getDate();
if ($zv > 0) $zv = bwc(bvc($zv), "full");

echo "aff.eas();\n";
echo "aff.ear(";
echo afh(aa0(aof($cnb->getFromAddress(), 'full_preview'))), ",";
echo afh(aa0(aaa($eap, 1000))), ","; echo afh($zv), ",";
echo afh(aa0(aaa($qn, 1000))). ",";
echo afh(aa0(aaa($eac, 1000))). ",";
echo afh(aa0(aaa($eao, 1000)));
echo ");\n";

if ($_POST['desktop'] == 'mailView.php') {

$eap = aaa($eap, 64);

$eap = strtr($eap, "\r\n", "  ");
$eap = addslashes($eap);

$eap = "'" . str_replace('<', "<'+'", $eap) . "'";

echo "parent.document.title = " . $eap . ";\n";
}


$eaj = array(
'folder' => $aek, 
'uid' => $abq->getUid(), 
'from' => $cnb->getFromAddress(), 
'cidsShownInline' => array() 
);


eat($atf, $eai);

echo "aff.eau($eaq);\n";


$eav = $abq->getFlags(); unset($abq, $bib, $atf); if ($eai != 0) {
unset($cnb); } 
if ($agi['mailMarkAsRead'] || $_POST['desktop'] == 'mailView.php')
dqg($aek, $zd, "read");

if ($eah == "print") {
echo "aff.eaw();\n";
}
if ($eah == "flag" || $eah == "unflag") {
dqg($aek, $zd, $eah);
}

if ($_POST['desktop'] == 'mailView.php') {
echo "aff.eax(true);\n";
}

$dil = substr(strstr($aek, "/"), 1); 
if ($eai == 0 && $agi['mailReceiptResponse'] != 0 && $dil != FLD_SENT && $dil != FLD_DRAFT) {
$eay = $cnb->getDispositionNotificationTo();
if ($eay != "") {
if (!in_array(KMS_MMDNSENT, $eav))
if ($agi['mailReceiptResponse'] == MDN_ALWAYS) {
dqk($aek, $zd, true);
} elseif($agi['mailReceiptResponse'] == MDN_MANUAL) {
echo "if (confirm(\"".aaz('mail-receipt-confirm')."\"))"
. "	aff.eaz(".afh($aek).",".$zd.");\n";
}
dqg($aek, $zd, "receiptsent");
}
}
}

function eat($bib, $eai)
{
global $eaj; global $bux;
static $eb0 = false;
static $eba = false;
static $ebb = 0;
if ($ebb++ > BODY_PART_MAX_CALL) return false; if (substr_count($eai, '.') > BODY_PART_MAX_DEPTH) return false; if (is_null($bib)) return false;
$ebc = strtolower($bib->getContentId());
if (is_array($eaj['cidsShownInline']) && in_array(strtolower($ebc), $eaj['cidsShownInline'])) return false;
$ebd = strtolower($bib->getContentType());
$ebe = strtolower($bib->getContentSubType());
$ebf = $ebd . "/" . $ebe;
$ebg = $bib->getContentTypeAttributes();
foreach ($ebg as $aoe) $ebh[strtolower($aoe['name'])] = strtolower($aoe['value']);
$ebi = strtolower($bib->getContentTransferEncoding());
$ebj = bwb(ebk($bib));
$ebl = ebm($bib);
if ($ebl == "winmail.dat" || $ebl == "smime.p7s") return false;
$ebn = ebo($bib);
$ebq = 'mailAttach/';
$ebr = ebs($ebl);
$ebt = '?part=' . $eai . '&folder=' . urlencode($eaj['folder']) . '&uid=' . $eaj['uid']; $ebp = $ebq . $ebr . $ebt;
$dio = "fileg";
$ebu = "attachment";
if ($ebf == "application/pdf")
$ebu = "inline";
if ($eb0) $ebv = "aff.ebw(\"<hr size='1'/>\");\n";
switch ($ebd) {
case "text":
switch ($ebn) {
case KMS_FCALENDAR:
case KMS_FTODO:
$eby = $ebh['method'];
$ebz = ($ebn == KMS_FCALENDAR);
$dio = ($ebz ? "fcalendarg" : "ftodog");
$abt = ($ebz ? $bib->toCalendarEvent() : $bib->toCalendarTodo());
if (!is_null($abt)) {
$aec = $abt->getSummary();
if (!$eby) $eby = ec0($abt->getMethod());
}
if (($eaj['folder'] == $GLOBALS['agh']."/".FLD_TRASH)
|| ($eaj['folder'] == $GLOBALS['agh']."/".FLD_SENT)) {
$eca = true;
}
if (($eby == 'request' || $eby == 'reply' || $eby == 'cancel') && !$eba && !$eca) {
ecb($bib, $eai);
$eba = true; $eb0 = true;
}
$ebx = $aec;
break;
case KMS_FCONTACT:
$dio = "fcontactg";
$bsk = $bib->toContact();
if (!is_null($bsk)) {
$ebx = $bsk->getCommonName();
if ($bsk->isDList()) {
$cew = true;
$dio = 'dlist';
}
}
break;
case KMS_FNOTE:
$eag = $bib->toStickyNote();
if (!is_null($eag)) {
$ebx = $eag->getSubject();
$a0x = $eag->getColor();
} else { $a0x = DEFAULT_NOTE_COLOR;
}
$dio = 'note' . $bux[$a0x]['iconColor'];
break;
default:
switch ($ebe) {
case "plain":
case "enriched":
case "html":
echo $ebv;
$ecc = ecd($bib, $eai);
if ($ecc) $eb0 = true;
$ebu = "inline";
break;
case "rfc822-headers":
$bvp = $bib->toMessageBody();
if ($bvp){
$afp = aof($bvp->getFromAddress(), 'full_preview');
$qn = aof($bvp->getToAddresses(), 'full_preview');
$zv = $bvp->getDate();

echo $ebv;
echo "aff.ebw(\"";
$agn = "<div style='background-color: #EEEEEE; padding: 4px'>";
if ($afp) $agn.= "<b><kerio:text id='msg-table-mail-from'/>:</b> " . aa0($afp) . "&nbsp;";
if ($qn) $agn.= "<b><kerio:text id='msg-table-mail-to'/>:</b> " . aa0($qn) . "<br>";
$agn.= "<b><kerio:text id='msg-table-mail-subject'/>:</b> " . aa0($bvp->getSubject()) . "<br>";
if ($zv) $agn.= "<b><kerio:text id='msg-table-mail-date'/>:</b> "
. bwc(bvc($zv), "full");
echo $agn . "</div><p>";
echo "\");\n";
$atf = $bvp->getContents();
$eb0 = false; eat($atf, $eai.".0");
$eb0 = true;
}
break;
}
}

break;



case "image":

$dio = "imageg";
if (in_array($ebe, explode(" ", "gif jp2 jpeg jpg pjpeg png x-png"))) { echo $ebv;
echo "aff.ebw(\"";
$ece = $GLOBALS['agi']['mailImgInline'];
if (!isset($ece) || $ece == 1) {
echo "<img src='$ebp' class='inline-attachment' defaultContextMenu='yes' alt='".aa0($ebl)."'>";
} else {
echo "<img src='gfx/image.gif' class='icon'> "
. "<a href='$ebp' target='_blank' defaultContextMenu='yes'><kerio:text id='mail-view-image'/></a>";
}
echo "\");\n";
$ebu = "inline";
$eb0 = true;
}
break;

case "message":

$dio = "mcomposeg";
if ($ebe == "rfc822") {
$bvp = $bib->toMessageBody();
if ($bvp == NULL) return false;
$afp = aof($bvp->getFromAddress(), 'full_preview');
$qn = aof($bvp->getToAddresses(), 'full_preview');
$eap = $bvp->getSubject();
$zv = $bvp->getDate();

$ebx = $eap;

echo $ebv;
echo "aff.ebw(\"";
$agn = "<div style='background-color: #EEEEEE; padding: 4px'>";
if ($afp) $agn.= "<b><kerio:text id='msg-table-mail-from'/>:</b> " . aa0($afp) . "&nbsp;";
if ($qn) $agn.= "<b><kerio:text id='msg-table-mail-to'/>:</b> " . aa0($qn) . "<br>";
$agn.= "<b><kerio:text id='msg-table-mail-subject'/>:</b> " . aa0($eap) . "<br>";
if ($zv) $agn.= "<b><kerio:text id='msg-table-mail-date'/>:</b> "
. bwc(bvc($zv), "full");
echo $agn . "</div><p>";
echo "\");\n";
$atf = $bvp->getContents(); $eb0 = false; eat($atf, $eai.".0"); $eb0 = true;
}
break;

case "multipart":

if ($bib->isContentType("multipart", "alternative")) { 
$ecf = $bib->toMultipartBody();
$ecg = $ecf->getCount();

$ech = array();
for ($eci = 0; $eci < $ecg; $eci++) {
$ecj = $ecf->getBodyPart($eci);
$ajk = strtolower($ecj->getContentType())."/".strtolower($ecj->getContentSubType());

if ($ajk == "multipart/related" || $ajk == "multipart/mixed") {
$eck = $ecj->toMultipartBody();
$ecl = $eck->getCount();
for ($ecm = 0; $ecm < $ecl; $ecm++) {
$ecn = $eck->getBodyPart($ecm);
if ($ajk == "multipart/related" && $ecn->isContentType("text", "html")) {
$ajk = "multipart/related/html"; }
elseif ($ajk == "multipart/mixed" && $ecn->isContentType("text", "*")) {
$ajk = "multipart/mixed/text"; }
}
}
$ech[$eai.".".$eci] = $ajk;
}
$eco = array_search("text/x-stickynote", $ech); if (!$eco)
$eco = array_search("text/x-vcard-dl", $ech); if (!$eco)
$eco = array_search("text/calendar", $ech);
if (!$eco)
$eco = array_search("text/html", $ech);
if (!$eco)
$eco = array_search("multipart/related/html", $ech);
if (!$eco)
$eco = array_search("multipart/mixed/text", $ech); if (!$eco)
$eco = array_search("text/plain", $ech);
if (count($ech) == 1) { $eco = key($ech);
}

for ($eci = 0; $eci < $ecg; $eci++) {
$ecp = $eai.".".$eci;
if ($ecp == $eco) {
$ecj = $ecf->getBodyPart($eci);
eat($ecj, $ecp);
}
}

} else { 
$ecf = $bib->toMultipartBody();
$ecg = $ecf->getCount();

for ($eci = 0; $eci < $ecg; $eci++) {
$ecj = $ecf->getBodyPart($eci);
eat($ecj, $eai.".".$eci);
}
}
break;

case "application":

if (in_array($ebe, explode(" ", "x-pkcs7-mime pkcs7-mime pkcs10"))) { echo $ebv;
echo "aff.ebw(\"";
echo "<kerio:text id='mail-encrypted1'/><br><br><kerio:text id='mail-encrypted2'/>";
echo "\");\n";
$eb0 = true;
}
break;

} 
if ((($ebl !== false) || isset($ebx)) && $ebf != "application/applefile") {
if (isset($ebx)) {
$ebt .= "&disp=attachment";
$ebp = $ebq . $ebr . $ebt;

if ($ebl == false) { $ebl = aaa($ebx, 64, '') . '.' . $GLOBALS['e0h'][$ebn];
$ebr = ebs($ebl);
$ebp = $ebq . $ebr . $ebt;
}
if ($ebn == KMS_FMAIL) { $ecq = '.' . $GLOBALS['e0h'][KMS_FMAIL];
if (strtolower(strrchr($ebl, '.')) != $ecq) {
$ebl .= $ecq;
$ebr = ebs($ebl);
$ebp = $ebq . $ebr . $ebt;
}
}
$ecr = "contextMenu='attachment'";
$ecs = "href=''";
if ($ebn == KMS_FCONTACT) {
$ect = $cew ? CONTACT_TYPE_DLIST : CONTACT_TYPE_CONTACT;
$ecs .= " attSubType='" . $ect . "'";
$ecu = ',\"' . $ect . '\"';
}
$ecs .= " onclick='ecv(\\\"$eai\\\",\\\"$ebn\\\"$ecu);return false'"
. " attType='" . $ebn . "' attPart='" . $eai . "' attUri='" . $ebp . "'";
$ecw = $ebx;

} elseif ($ebf == 'text/html') {
$ecx = $ebq . $ebr . $ebt . "&disp=inline";
$ecy = $ebq . $ebr . $ebt . "&disp=attachment";
$ecs = "href='" . $ecx . "' target='_blank'"
. " attUriOpen='" . $ecx . "' attUri='" . $ecy . "'";
$ecr = "contextMenu='attachment'";
$ecw = $ebl;

} else {
$ebt .= "&disp=" . $ebu;
$ebp = $ebq . $ebr . $ebt;

$ecr = "defaultContextMenu='yes'";

$ecz = strrchr($ebl, '.');
if (strcasecmp($ecz, '.exe') == 0 || strcasecmp($ecz, '.dll') == 0) {
$ebp .= '&ext=' . $ecz;
}

$ecs = "href='".$ebp."' target='_blank' ";
$ecw = $ebl;
}

echo "aff.ed0(\"";
echo "<a $ecs $ecr>";
echo "<img src='gfx/".$dio.".gif' height='16' align='top' " . $ecr . ">";
echo "<span>";
echo aa0(ahi(aaa($ecw, 64)))."</span></a> ($ebj)";
echo "\");\n";
}
}

function ebo($eda)
{
$ebd = $eda->getContentType();
$ebe = $eda->getContentSubType();
$ebg = $eda->getContentTypeAttributes();
foreach ($ebg as $aoe) {
if (strtolower($aoe['name']) == 'component') {
$dfo = $aoe['value'];
break;
}
}
switch (strtolower($ebd . '/' . $ebe . '/' . $dfo)) {
case "text/directory/":
case "text/x-vcard/":
case "text/x-vcard-dl/":
case "text/vcard/":
$edb = KMS_FCONTACT;
break;
case "text/calendar/":
case "text/calendar/vevent":
$edb = KMS_FCALENDAR;
break;
case "text/calendar/vtodo":
$edb = KMS_FTODO;
break;
case "text/x-stickynote/":
$edb = KMS_FNOTE;
break;
default:
$edb = KMS_FMAIL;
}
return $edb;
}

function ecd($bib, $eai)
{
global $agi;
$ebd = strtolower($bib->getContentType()) . "/" . strtolower($bib->getContentSubType());
$edc = edd($bib, false);
if (strlen(trim($edc)) == 0) return false; $ede = ($ebd == "text/html" ? edf($edc) : "");
$edg = "";
$ebg = $bib->getContentTypeAttributes();
foreach ($ebg as $aoe) {
if (strtolower($aoe['name']) == 'charset') {
$edg = strtolower($aoe['value']);
break;
}
}
$edh = $edg;
if ($ede != "" && $ede != $edg) {
$edi = kerio_convert($ede, "utf-8", $edc);
if (kerio_convert("utf-8", $ede, $edi) == $edc) {
$edh = "";
$edc = $edi;
}
}

if ($edh && $edh != "utf-8") {
$edc = Kerio_convert($edh, "utf-8", $edc);
}

$edc = edj($edc, $ebd, MODE_DISPLAY_FULL, $eai, $agi['mailImgAllowRemote']);

if ($bib->isContentType("text","html")) {
$edc = ahi($edc, 0, false);
} elseif ($bib->isContentType("text","plain")) {
$edc = ahi($edc, 0, false);
} else {
$edc = ahi($edc, 1, false);
}

echo "aff.ebw(\"";
echo $edc;
echo "\");\n";
return true;
}


function edd($bib, $edk = true) {

$edl = strtolower($bib->getContentType());
$ebg = $bib->getContentTypeAttributes();

foreach ($ebg as $aoe) {
if (strtolower($aoe['name']) == 'charset') $edh = strtolower($aoe['value']);
}

$edc = "";
$abv = $bib->openDecodedContentsStream();
while (!feof($abv)) {
$edc .= fread($abv, 81920);
}
fclose($abv);

if ($edk && $edl == "text" && $edh && strtolower($edh) != "utf-8") {
$edc = Kerio_convert($edh, "utf-8", $edc);
}

return $edc;
}


function ebm($bib) {
$ebg = $bib->getContentDispositionAttributes();
foreach ($ebg as $aoe) {
if (!strcasecmp($aoe['name'], 'filename')) return preg_replace("/attachment/i", "attachmen_", $aoe['value']); }
$ebg = $bib->getContentTypeAttributes();
foreach ($ebg as $aoe) {
if (!strcasecmp($aoe['name'], 'name')) return preg_replace("/attachment/i", "attachmen_", $aoe['value']); }
return false;
}

function ebk($bib)
{
$edm = strtolower($bib->getContentTransferEncoding());
$avb = $bib->getContentLength();
if ($edm == 'base64') {
$avb = $avb / 1.33;
}
return $avb;
}


function edo($bib, $eai = 0)
{
static $ebb = 0;

if ($ebb++ > BODY_PART_MAX_CALL) return array(); if (substr_count($eai, '.') > BODY_PART_MAX_DEPTH) return array(); 
$eay = $bib->getContentDisposition();
$ebd = strtolower($bib->getContentType());
$ebf = $ebd . "/" . strtolower($bib->getContentSubType());

if ($ebf == "multipart/mixed"
|| $ebf == "multipart/related"
|| $ebf == "multipart/parallel"
|| $ebf == "multipart/signed"
|| $ebf == "multipart/alternative" || $ebf == "multipart/appledouble") {
$ecf = $bib->toMultipartBody();
$ecg = $ecf->getCount();

for ($eci = 0; $eci < $ecg; $eci++) {
$ecj = $ecf->getBodyPart($eci);
$edp = $eai.".".$eci;
$eae = edo($ecj, $edp);
$edq = array_merge($edq, $eae);
}

} elseif( ($ebd != "text" || $eay == "attachment" || $eay == "inline")
&& $ebd != "multipart" && $ebf != "application/applefile") {

$ebg = $bib->getContentTypeAttributes();
foreach ($ebg as $aoe)
if (strtolower($aoe['name']) == 'component') $dfo = strtolower($aoe['value']);

$eae['type'] = strtolower($bib->getContentType()."/".$bib->getContentSubType());
if ($dfo)
$eae['component'] = $dfo;
$eae['size'] = ebk($bib);
$eae['name'] = ebm($bib);
if (!$eae['name'])
$eae['name'] = strtolower($bib->getContentType());
$eae['part'] = $eai;
return (array($eae));
}
return $edq;
}




function akm($aoe, $bqi = 'angle')
{
if ($aoe['name'] == $aoe['address'])
return $aoe['address'];

$dn = btj($aoe['name']);

if (strlen($dn) > 0) {
switch($bqi) {
case 'square': $bss = ' [mailto:'.$aoe['address'].']'; break;
case 'angle':
default: $bss = ' <'.$aoe['address'].'>'; break;
}
} else {
$bss = $aoe['address'];
}

return $dn.$bss;
}


function edr($cnb, $bqi = 'text')
{
$qn = $cnb->getToAddresses();
foreach ($qn as $bss) {
if ($cvj) $cvj.= ", ";
$cvj.= akm($bss);
}

$zv = $cnb->getDate();
$zv = ($zv > 0 ? aan("%kdate %ktime", bvc($zv)) : "");

$bqp = array(
array(aaz('mail-to'), $cvj),
array(aaz('mail-subject'), $cnb->getSubject()),
array(aaz('mail-receipt-mail-date'), $zv)
);

$eds = stripslashes(aaz('mail-receipt-mail-text1'));
$edt = stripslashes(aaz('mail-receipt-mail-text2')) . " "
. aan("%kdate %ktime", bvc(mktime()));

switch ($bqi) {

case "html":
$agn = "<p style='font: 12px Verdana, Arial, sans-serif'>".$eds."</p>\n";
$agn.= "<table style='font: 12px Verdana, Arial, sans-serif'>\n";
foreach($bqp as $bqs) {
if (strlen($bqs[1]) > 0) {
$agn.= "<tr><td><b>" . $bqs[0] . ":</b></td><td>" . $bqs[1] . "</td></tr>\n";
}
}
$agn.= "</table>\n\n<p style='font: 12px Verdana, Arial, sans-serif'>".$edt."</p>\n";
break;

case "text":
default:
$agn = $eds."\n\n";
foreach($bqp as $bqs) {
if (strlen($bqs[1]) > 0) {
$agn.= $bqs[0] . ": " . $bqs[1] . "\n";
}
}
$agn.= "\n".$edt."\n";
}

return $agn;
}


function dqk($aek, $zd, $edu = false)
{
global $ak, $abm;

$cnb = cnc($aek, KMS_FMAIL, $zd);

$afp = akm(array("name"=>$abm->getFullName(), "address"=>$abm->getUserName()));
$qn = $cnb->getDispositionNotificationTo();
$eap = aaz('mail-receipt-mail-subject').': '.$cnb->getSubject();

$edv['From'] = kerio_encode_address_header('From', $afp);
$edv['To'] = kerio_encode_address_header('To', $qn);
$edv['Subject'] = kerio_encode_header('Subject', $eap);

$edw = ""; $edx = edy($qn);

$edz = $ak->getServerInfo();
$ee0 = $edz->getHostName();
$eea = SERVER_SOFTWARE . ' WebMail';
$eeb = $edu ? "automatic-action/MDN-sent-automatically" : "manual-action/MDN-sent-manually";

$eec['Reporting-UA'] = $ee0."; ".$eea;
$eec['Final-Recipient'] = "rfc822; ".$abm->getUserName();
if ($cnb->getMessageId()) {
$eec['Original-Message-ID'] = $cnb->getMessageId();
}
$eec['Disposition'] = $eeb."; displayed";

foreach ($eec as $eed => $du) {
$du = wordwrap($du, LINE_MAX, "\r\n\t");
$eee.= "$eed: $du\r\n";
}

$bvu = array(
array(
'type'=>'multipart/alternative',
'content'=>array(
array(
'type'=>'text/plain',
'content'=>edr($cnb, 'text')
),
array(
'type'=>'text/html',
'content'=>edr($cnb, 'html')
)
),
),
array(
'type'=>'message/disposition-notification',
'content'=>$eee
)
);

$ebd = 'multipart/report';
$ebh = array('report-type'=>'disposition-notification');

$eef = edn($edv, false, $bvu, $ebd, $ebh);

$eeg = eeh($eef, $edw, $edx, false);
return $eeg;
}


function bic($bib, $eej, $d = 'getBodyContent', $eai = 0)
{
static $ebb = 0;

if ($ebb++ > BODY_PART_MAX_CALL) return null; if (substr_count($eai, '.') > BODY_PART_MAX_DEPTH) return null; 
settype($eej, "string");
settype($eai, "string"); if ($eej === $eai) {

switch ($d) {
case 'getBodyContent':
return edd($bib, false); break;
case 'returnBodyPart':
return $bib;
break;
case 'getCalendarFromBodyPart':
return $bib->toCalendarEvent();
break;
case 'getContactFromBodyPart':
return $bib->toContact();
break;
case 'outputBodyPart':
return eek($bib);
break;
case 'getTodoFromBodyPart':
return $bib->toCalendarTodo();
break;
case 'getNoteFromBodyPart':
return $bib->toStickyNote();
break;
}

}

if (substr($eej, 0, strlen($eai)) != $eai) {
return NULL;
}

$ebd = $bib->getContentType();
switch (strtolower($ebd)) {
case "multipart":
$ecf = $bib->toMultipartBody();
if (is_null($ecf))
return false;

$ecg = $ecf->getCount();
for ($eci = 0; $eci < $ecg; $eci++) {
$ecj = $ecf->getBodyPart($eci);
$ni = bic($ecj, $eej, $d, $eai.".".$eci);
if (!is_null($ni)) return $ni;
}
break;
case "message":
$bvp = $bib->toMessageBody(); $ecj = $bvp->getContents(); $ni = bic($ecj, $eej, $d, $eai.".0");
if (!is_null($ni)) return $ni;
break;
default:
return NULL;
} }


function ean($bib, $eai)
{
return bic($bib, $eai, 'returnBodyPart');
}


function eem($eel, $av)
{
global $ak;

$qp = $ak->getMyUserInfo();
$aek = "~" . $qp->getUserName() . "/" . $eel;

$abi = $ak->getFolderStore();

$abo = $abi->openMailFolder($aek);
if (is_null($abo)) {
$abi->createFolder($aek, KMS_FMAIL);
$abo = $abi->openMailFolder($aek);
if (is_null($abo)) {
echo "<script>alert('Unable to open ".$aek."');</script>";
return false;
}
}

$af0 = $abo->insertMessage();
if (!is_null($af0)) {
$aey = $af0->messageWrite($av);
}
if (!$aey) {
echo "<script>alert('Unable to save message to ".$aek."');</script>";
return false;
}


if ($eel == FLD_DRAFT) {
$eav = array(KMS_MDRAFT);
}
else {
$eav = array(KMS_MSEEN);
}

$aey = $af0->setFlags($eav, KMS_FLAGSADD);
if (!$aey) echo "// Unable to setFlags()\n";

$aey = $af0->commit($een);
if (!$aey) {
echo "<script>alert('Unable to save message to ".$aek."');</script>";
return false;
}
}


function ecb($bib, $eai) {

global $abm, $eaj;

$afp = $eaj['from'];

$ebg = $bib->getContentTypeAttributes();
foreach ($ebg as $aoe) {
if (strtolower($aoe['name']) == 'method') $eby = strtolower($aoe['value']);
if (strtolower($aoe['name']) == 'component') $dfo = strtolower($aoe['value']);
}
$ebn = ($dfo == "vtodo") ? KMS_FTODO : KMS_FCALENDAR;
$eeo = ($ebn == KMS_FCALENDAR) ? "event" : "task";

$anx = ($ebn == KMS_FCALENDAR) ? $bib->toCalendarEvent() : $bib->toCalendarTodo();
unset($bib); 
if (is_null($anx)) {
echo "alert('Error: failed to display ".$dfo."');";
return false;
}

if (!$eby) $eby = ec0($anx->getMethod());

if ($eby == "request") {
echo "aff.eep = '".$ebn."';\n";
echo "aff.eeq = '".$eai."';\n";
echo 'aff.document.getElementById("buttonCalendar").setAttribute("aoy",' . $anx->getStartDateTime() . ");\n";
echo "aff.document.getElementById(\"messageToolbarEventPattern\").style.display = 'block';\n";
}

$afc = $anx->getAttendees();
foreach ($afc as $aoe) {
$bqk[$aoe['role']][] = $aoe['address'];
if (strtolower($aoe['address']) == strtolower($afp['address']))
$eer = $aoe;
}

if ($eby == "reply" && count($eer) > 0) {
$qp = $eer['name'] ." &lt;".$eer['address']."&gt;";
switch ($eer['status']) {
case KMS_ASACCEPTED:
$dio = "accept.gif";
$bvp = $qp.' <kerio:text id="mail-'.$eeo.'-user-accepted"/>';
break;
case KMS_ASTENTATIVE:
$dio = "tentative.gif";
$bvp = $qp.' <kerio:text id="mail-'.$eeo.'-user-tentative"/>';
break;
case KMS_ASDECLINED:
$dio = "decline.gif";
$bvp = $qp.' <kerio:text id="mail-'.$eeo.'-user-declined"/>';
break;
default:
echo "alert('unknown status ".$eer['status']."');\n";
}
$ees = "<img src='gfx/".$dio."' class='icon'>&nbsp;$bvp<br>";

$cgf = eet("(@MessageId = $1)", array($anx->getUid()), $ebn);
if (count($cgf) > 0) {
$abo = abp($cgf[0]['folder'], $ebn);
$aep = abr($abo, $ebn, KMS_FAREADWRITE);
$aep->gotoUid($cgf[0]['uid']);
$eeu = ($ebn == KMS_FCALENDAR) ? $aep->getCalendarEvent() : $aep->getCalendarTodo();
$eev = $eeu->copy();
$bqj = $eev->getAttendees();
$cge = false;
for ($az = 0; $az < count($bqj); $az++) {
if (strtolower($bqj[$az]['address']) == strtolower($afp['address'])) {
$cge = true;
$bqj[$az]['status'] = $eer['status'];
$eev->setAttendee($bqj[$az], $az);
}
}
if (!$cge) { $eev->addAttendee($eer); }
$aey = ($ebn == KMS_FCALENDAR)
? $aep->saveCalendarEvent($eev)
: $aep->saveCalendarTodo($eev);
unset($aep);
if (!$aey)
echo "<script type='text/javascript'>alert('".'<kerio:text id="mail-'.$eeo.'-err-update"/>'.")</script>";
}
echo "aff.afl();\n";
}
if ($eby == "cancel") {
$dio = "decline.gif";
$bvp = '<kerio:text id="mail-'.$eeo.'-canceled"/>';
$ees = "<img src='gfx/".$dio."' class='icon'>&nbsp;$bvp<br>";
$cgf = eet("(@MessageId = $1)", array($anx->getUid()), $ebn);
if (count($cgf) > 0) {
dqd($cgf[0]['folder'], $cgf[0]['uid'], true, "false");
}
}
$agn = "<div style='background-color: #EEEEEE; padding: 4px'>";
$agn.= "<span style='font-size: 16px; font-weight: bold;'>".aa0($anx->getSummary())."</span><br>";
if ($eby == 'reply' && count($cgf) == 0) {
$agn .= '<span style="padding-left:16px;">&nbsp;';
$agn .= ($ebn == KMS_FCALENDAR) ? '<kerio:text id="event-is-not-in-calendar"/>'
: '<kerio:text id="todo-is-not-in-tasks"/>';
$agn .= '</span><br>';
}
$agn.= $ees;
$agn.= "<hr>";
if (count($bqk[KMS_ARREQPARTICIPANT]) > 0)
$agn.= '<b>' . bqt(aaz('eventtodo-attendees-requested')). ':</b> '.aa0(implode(", ", $bqk[KMS_ARREQPARTICIPANT]))."<br>";
if (count($bqk[KMS_AROPTPARTICIPANT]) > 0)
$agn.= '<b>' . bqt(aaz('eventtodo-attendees-optional')) . ':</b> '.aa0(implode(", ", $bqk[KMS_AROPTPARTICIPANT]))."<br>";
switch ($ebn) {
case KMS_FCALENDAR:
$agn.= '<b><kerio:text id="mail-event-when"/></b>: '.bqd($anx)."<br>"
. '<b><kerio:text id="eventtodo-location"/></b>: '.aa0($anx->getLocation());
break;
case KMS_FTODO:
$eew = ($anx->getDueDateTime() > 0) ? aan("%a %kdate", $anx->getDueDateTime()) : aaz('common-unknown');
$agn.= '<b><kerio:text id="todo-duetime"/></b>: ' . $eew . "<br>"
. '<b><kerio:text id="todo-status"/></b>: '.bqb($anx->getStatus())."<br>"
. '<b><kerio:text id="eventtodo-priority"/></b>: '.aio($anx->getPriority())."<br>"
. '<b><kerio:text id="todo-percent"/></b>: '.$anx->getPercentComplete();
break;
}
$agn.= "</div><p>";
echo "aff.ebw(" . afh($agn) . ");\n";
echo "aff.ebw(\"";
$edc = aa0($anx->getDescription()); if (eex($edc)) $edc = eey($edc, "full");
echo ahi($edc);
echo "\");\n";
}

function eez($anx, $ebn, $eby) {
switch ($ebn) {
case KMS_FCALENDAR:
$ef0 = array();
$ef0['content'] = bqh($anx, 'html');
$ef0['type'] = 'text/html';
$efa = array();
$efa['content'] = $anx->toString();
$efa['type'] = 'text/calendar';
$efa['typeAttrs']['component'] = "VEVENT";
$efa['typeAttrs']['method'] = $eby;
$efa['typeAttrs']['name'] = "meeting.ics";
$efa['class'] = 'urn:content-classes:calendarmessage'; $efb = bqh($anx, 'text');
$efc = array($ef0, $efa);
break;
case KMS_FTODO:
$ef0 = array();
$ef0['content'] = efd($anx, 'html');
$ef0['type'] = 'text/html';
$efa = array();
$efa['content'] = $anx->toString();
$efa['type'] = 'text/calendar';
$efa['typeAttrs']['component'] = "VTODO";
$efa['typeAttrs']['method'] = $eby;
$efa['typeAttrs']['name'] = "task.ics";
$efa['class'] = 'urn:content-classes:task'; $efb = efd($anx, 'text');
$efc = array($ef0, $efa);
break;
default:
$efb = '';
$efc = '';
break;
}
$ebd = "multipart/alternative";
return array('mailBody' => $efb, 'mailAttachments' => $efc, 'contentType' => $ebd);
}

function dqp($aed, $ebn, $zd, $d) {
$abo = abp($aed, $ebn);
if ($abo) {
echo aif($abo, $ebn, $zd, $d);
}
}

function aif($abo, $ebn, $zd, $d, $efe = '', $aid = array()) {
global $ak, $abm;
$ahz = '';
$eeo = ($ebn == KMS_FCALENDAR) ? "event" : "task";
$abq = abr($abo, $ebn, KMS_FAREADWRITE);
if ($abq->gotoUid($zd)) {
switch ($ebn) {
case KMS_FCALENDAR:
$yw = $abq->getCalendarEvent();
break;
case KMS_FTODO:
$yw = $abq->getCalendarTodo();
break;
default:
return $ahz; break;
}
}
else {
$aek = $abo->getName();
aeq('E_MESSAGE_BADUID', $aek);
aer('sendEvent', 'E_MESSAGE_BADUID', 'folder: ' . $aek . '; uid: ' . base_convert($zd, 10, 16));
}
$anx = $yw->copy();
$bqj = $anx->getAttendees(); $eff = akf($anx);
$efg = array(); $cvj = ''; $efh = ''; if ($d != 'reply') { $efh = akm($eff);
$efi = $eff['address'];
$bo = substr(strrchr($eff['address'], '@'), 1);
if (sizeof($aid) > 0) $bqj = $aid;
for ($az = 0; $az < count($bqj); $az++) {
$aoe = $bqj[$az];
$qn = $aoe['address'];
if (!$qn) $qn = $aoe['name'];
if (!strstr($qn, '@')) $qn.= '@'.$bo;
$aoe['address'] = $qn;
$anx->setAttendee($aoe, $az);
if (!strstr($cvj, $qn) && $aoe['rsvp'] && !in_array($aoe['address'], $abm->getAllowedEmailAddresses())) {
if ($cvj) $cvj.= ",";
$cvj.= akm($aoe);
$efg[] = $qn;
}
}
if (count($efg) == 0) {
return $ahz; }
}
elseif ($efe != '') { $cvj = akm($eff);
$efg[] = $eff['address'];
$efj = $abm->getAllowedEmailAddresses();
$efj = array_unique($efj);
foreach ($bqj as $afd) {
if (in_array($afd['address'], $efj)) {
$efh = akm($afd);
$efk = $afd;
break;
}
}
if (!$efh) $efh = $efj[0];
}
else {
return $ahz; }
if ($d == "cancelEvent") {
$efl = "Canceled: " . $yw->getSummary();
$anx->setMethod(KMS_MCANCEL);
$eby = "CANCEL";
$anx->clearAttendees();
foreach ($aid as $afd) {
$anx->addAttendee($afd);
}
}
elseif ($d != 'reply') {
if ($d == "sendEventUpdatePrompt") $efm = true;
if ($d == "sendEventUpdate" || $d == "sendEventUpdatePrompt") $efn = true;
$efl = $yw->getSummary();
if ($ebn == KMS_FTODO) $efl = "Task request: ".$efl;
if ($efn) $efl = "Updated: ".$efl;
switch ($yw->getPriority()) {
case 1: $efo = "1 (Highest)"; break;
case 9: $efo = "5 (Lowest)"; break;
default: $efo = "";
}
$bqj = $anx->getAttendees();
for ($az = 0; $az < count($bqj); $az++) {
$aoe = $bqj[$az];
$qn = $aoe['address'];
if ($aoe['rsvp'] && !in_array($aoe['address'], $abm->getAllowedEmailAddresses())) {
$aoe['status'] = KMS_ASNEEDSACTION;
$aoe['mailSent'] = true;
}
$anx->setAttendee($aoe, $az);
}
$aey = ($ebn == KMS_FCALENDAR)
? $abq->saveCalendarEvent($anx)
: $abq->saveCalendarTodo($anx);
unset($abq, $abo);
if (!$aey) {
$ahz .= 'alert(\'<kerio:text id="mail-' . $eeo . '-err-update"/>\');' . "\n";
return $ahz;
}
$anx->setMethod(KMS_MREQUEST);
$eby = "REQUEST";
}
elseif ($efe != '') {
$efl = 'Declined: ' . $yw->getSummary();
switch ($efe) {
case 'accepted': $efe = KMS_ASACCEPTED; break;
case 'declined': $efe = KMS_ASDECLINED; break;
case 'tentative': $efe = KMS_ASTENTATIVE; break;
default:
break;
}
$efk['status'] = $efe;
$anx->clearAttendees();
$anx->addAttendee($efk);
$anx->setMethod(KMS_MREPLY);
$eby = 'REPLY';
}
else {
return $ahz;
}
$efp = eez($anx, $ebn, $eby); $edv['Message-ID'] = aic($efl);
$edv['From'] = kerio_encode_address_header('From', $efh);
$edv['To'] = kerio_encode_address_header('To', $cvj); $edv['Subject'] = kerio_encode_header('Subject', $efl);
if ('cancelEvent' == $d) {
$efo = '1 (Highest)';
}
if ($efo) {
$edv['X-Priority'] = $efo;
}
$eef = edn($edv,
$efp['mailBody'],
$efp['mailAttachments'],
$efp['contentType']);
$efq = eeh($eef, $efi, $efg);
eem(FLD_SENT, $eef);
if ($efm) {
$ahz .= 'alert(\'<kerio:text id="mail-' . $eeo . '-sent"/>\');' . "\n"
. 'aff.afl();' . "\n" . 'var c0v = aff.afi.afj;'
. 'if (c0v) c0v.afk();' . "\n";
}
if ($d == 'cancelEvent' && sizeof($aid) == 0) {
$ahz .= 'alert(\'<kerio:text id="mail-' . $eeo . '-cancel-sent"/>\');' . "\n";
}
if ($d == 'reply' && $efe != '' && $efq) {
$ahz .= 'alert(\'<kerio:text id="mail-' . $eeo . '-decline-sent"/>\');' . "\n";
}
return $ahz;
}

function dqq($aek, $dfq, $efr, $aoi, $aav) {
$aoi = ($aoi == 'false') ? false : true;
$aav = ($aav == 'false') ? false : true;
$efs = explode(',', $efr);
if (sizeof($efs)) foreach($efs as $zd) {
$yw = cnc($aek, $dfq, $zd);
if (aau($yw) && $aoi) {
$abo = abp($aek, $dfq);
echo aif($abo, $dfq, $zd, 'cancelEvent');
}
if (aaw($yw) && $aav) {
if (is_null($abo)) {
$abo = abp($aek, $dfq);
}
echo aif($abo, $dfq, $zd, 'reply', 'declined');
}
}
dqd($aek, $efr, false, "false");
}

function aie($aes, $afc, $d) {
$eft = $aes->getAttendees();
$aih = array();
$aid = array();
$aes->clearAttendees();
if (!empty($afc)) {
foreach($afc as $afd) {
$efu = kerio_parse_address_header($afd['name']);
$efv = $efu[0];
$afd['address'] = $efv['address'];
$afd['name'] = $efv['name'];
if ('' == $afd['name']) {
$afd['name'] = $afd['address'];
}
$aih[] = $afd;
$aes->addAttendee($afd);
}
}
if ('sendEventUpdate' != $d) {
return $aid; }
foreach ($eft as $efw) {
$efx = true;
foreach ($aih as $efy) {
if ($efy['address'] == $efw['address']) {
$efx = false;
break;
}
}
if ($efx) {
$aid[] = $efw;
}
}
return $aid;
}


function aic($bwk)
{
global $ak;
$edz = $ak->getServerInfo();

$ps = "<".gmdate("YmdHis")."." . substr(md5(microtime().$bwk),0,8)
. "@".$edz->getHostName().">";

return $ps;
}


function aof($bss, $bqi = 'short')
{
if (!is_array($bss) || count($bss) == 0) return false;

if (!isset($bss['name']) && !isset($bss['address'])) {
foreach ($bss as $aoe) {
$ni[] = aof($aoe, $bqi);
}
} else {
switch ($bqi) {
case "short":
$ni[] = (strlen($bss['name']) > 0) ? $bss['name'] : $bss['address'];
break;

case 'full_preview':
$ni[] = (strlen($bss['name']) > 0) ? $bss['name'] . ' <' . $bss['address'] . '>' : $bss['address'];
break;

case 'square_preview':
$ni[] = (strlen($bss['name']) > 0) ? $bss['name'] . ' [mailto:' . $bss['address'] . ']' : $bss['address'];
break;

case "full":
$ni[] = akm($bss);
break;
}
}

return implode(", ", $ni);
}


function ec0($eby) {
switch ($eby) {
case KMS_MPUBLISH: return "publish"; break;
case KMS_MREQUEST: return "request"; break;
case KMS_MREPLY: return "reply"; break;
case KMS_MADD: return "add"; break;
case KMS_MCANCEL: return "cancel"; break;
case KMS_MREFRESH: return "refresh"; break;
case KMS_MCOUNTER: return "counter"; break;
case KMS_MDECLINECOUNTER: return "declinecounter"; break;
default : return false;
}
}


function eet($efz, $mq, $dfq)
{
global $abm;
$aek = "~".$abm->getUserName()."/".($dfq == KMS_FCALENDAR ? FLD_CALENDAR : FLD_TODO);
$abo = abp($aek, $dfq);
$ala = $abo->searchMessages(&$eg0, &$alc, $efz, $mq);
$abq = abr($abo, $dfq);
$abq->setSubset($eg0);
for ($abq->gotoNumber(0), $az = 0; $abq->isValid() ; $abq->gotoNext(),++$az) {
$yw = ($dfq == KMS_FCALENDAR) ? $abq->getCalendarEvent() : $abq->getCalendarTodo();
if (!is_null($yw))
$a0e[] = array("uid"=>$abq->getUID(), "folder"=>$aek);
}
unset($abo, $abq);
return $a0e;
}
?>
