<?php

$bvm = array(
'E_FOLDER_OPEN' => array('log' => "Cannot open folder", 'user' => "<kerio:text id='log-e-folder-open'/>"),
'E_FOLDER_CREATE' => array('log' => "Unable to create folder", 'user' => "<kerio:text id='log-e-folder-create'/>"),
'E_FOLDER_RENAME' => array('log' => "Unable to rename folder", 'user' => "<kerio:text id='log-e-folder-rename'/>"),
'E_FOLDER_DELETE' => array('log' => "Unable to delete folder", 'user' => "<kerio:text id='log-e-folder-delete'/>"),
'E_FOLDER_CONNECT' => array('log' => "Unable to connect folder of user", 'user' => ""),
'E_FOLDER_SETACL' => array('log' => "Unable to set access rights", 'user' => "<kerio:text id='log-e-folder-setacl'/>"),
'E_MESSAGE_COPY' => array('log' => "Unable to copy message", 'user' => "<kerio:text id='log-e-message-copy'/>"),
'E_MESSAGE_MOVE' => array('log' => "Unable to move message", 'user' => "<kerio:text id='log-e-message-move'/>"),
'E_MESSAGE_DELETE' => array('log' => "Unable to delete message", 'user' => "<kerio:text id='log-e-message-delete'/>"),
'E_MESSAGE_SETFLAG' => array('log' => "Unable to set flag", 'user' => "<kerio:text id='log-e-message-setflag'/>"),
'E_MESSAGE' => array('log' => "Message error", 'user' => "<kerio:text id='log-e-message'/>"),
'E_MESSAGE_SAVE' => array('log' => "Cannot save message", 'user' => "<kerio:text id='log-e-message-save'/>"),
'E_SETTINGS_SAVE' => array('log' => "Unable to save settings", 'user' => "<kerio:text id='log-e-settings-save'/>")
);

function hhd($hpm, $hpn = "") {
global $bvm;

$_SESSION['warning']['red'] = true; 
switch ($hpm) {
case 1001:
case 1002:
case 1051:
case 1201:
case 1211:
case 1221:
case 1222:
case 1241:
case 1301:
case 9999:
$bwj = 'E_FOLDER_OPEN';
break;

case 1003:
case 1011:
$bwj = 'E_MESSAGE_COPY';
break;

case 1010:
$bwj = 'E_MESSAGE_MOVE';
break;

case 1004:
$bwj = 'E_MESSAGE_SETFLAG';
break;

case 1005:
$bwj = 'E_MESSAGE_DELETE';
break;

case 1101:
case 1431:
$bwj = 'E_SETTINGS_SAVE';
$_SESSION['warning']['red'] = false;
break;

case 1501:
case 1502:
case 1503:
case 1504:
case 1505:
$bwj = 'E_SETTINGS_SAVE';
break;

case 1232:
$bwj = 'E_MESSAGE';
break;

case 1231:
case 1302:
case 1303:
$bwj = 'E_MESSAGE_SAVE';
break;

case 1401:
$bwj = 'E_FOLDER_CREATE';
break;

case 1411:
$bwj = 'E_FOLDER_RENAME';
break;

case 1421:
$bwj = 'E_FOLDER_DELETE';
break;

case 1461:
$bwj = 'E_FOLDER_CONNECT';
$_SESSION['warning']['red'] = false;
break;

case 1451:
$bwj = 'E_FOLDER_SETACL';
$_SESSION['warning']['red'] = false;
break;
}

if ($bvm[$bwj]['user'] !== "") $_SESSION['warning']['txt'] = "<kerio:text id='common-error'/>: " . $bvm[$bwj]['user'];

$bvp = "webmail mini error #" . $hpm . "/" . $bvm[$bwj]['log'];
if (is_array($hpn)) {
foreach ($hpn as $cea) $bvp .= ":" . (is_array($cea) ? implode(",", $cea) : $cea);
}
elseif ($hpn != "") {
$bvp .= ":" . $hpn;
}
kerio_log(KMS_LOG_ERROR, $bvp);
}
?>
